/*******************************************************************************
 * FoxAdmin generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxAdmin extends FoxPC
    config(Game)
    hidecategories(Navigation);

exec function Message(const string Message)
{
    ServerMessage(Message);
    //return;    
}

reliable server function ServerMessage(const string Message)
{
    WorldInfo.Game.Broadcast(none, "ADMIN SEZ:" @ Message, 'AdminMessage');
    //return;    
}

exec function TestDialog(const optional string EventID, const optional string Arg1, const optional string Arg2, const optional string Arg3)
{
    local array<string> args;

    args.AddItem(EventID);
    // End:0x40
    if(Arg1 != "")
    {
        args.AddItem(Arg1);
    }
    args.AddItem("Teammate");
    // End:0x7D
    if(Arg2 != "")
    {
        args.AddItem(Arg2);
    }
    // End:0xA3
    if(Arg3 != "")
    {
        args.AddItem(Arg3);
    }
    args.AddItem("Friendly");
    Pawn.PlayAkDialog(args, true);
    //return;    
}

exec function AddToken(byte TokenType, int Num)
{
    ServerAddToken(TokenType, Num);
    //return;    
}

reliable server function ServerAddToken(byte TokenType, int Num)
{
    FoxGameMP_OS(WorldInfo.Game).TokensCollected(Pawn, TokenType, Num);
    //return;    
}

exec function ToggleNodeWidgets(bool bToggle)
{
    // End:0xC4
    if(((DynamicUI != none) && DynamicUI.Menu != none) && DynamicUI.Menu.ArmoryInfo != none)
    {
        DynamicUI.Menu.ArmoryInfo.bShowNodeWidgets = bToggle;
    }
    //return;    
}

exec function KillPlayer(const string PlayerName)
{
    ServerKillPlayer(PlayerName);
    //return;    
}

reliable server function ServerKillPlayer(const string PlayerName)
{
    local Pawn P;

    // End:0xA6
    foreach DynamicActors(class'Pawn', P)
    {
        // End:0xA5
        if(P.PlayerReplicationInfo.GetHumanReadableName() ~= PlayerName)
        {
            P.TakeDamage(1000, none, vect(0.0, 0.0, 0.0), vect(0.0, 0.0, -1000.0), class'FoxDamageType_Smite');
        }        
    }    
    //return;    
}

exec function EndGame()
{
    ServerEndGame();
    //return;    
}

reliable server function ServerEndGame()
{
    ServerMessage("The Almighty Admin has decided that he wins");
    WorldInfo.Game.EndGame(PlayerReplicationInfo, "The Almighty Admin has decided that he wins");
    //return;    
}

exec function RemoveAllAmmo()
{
    ServerRemoveAllAmmo();
    //return;    
}

reliable server function ServerRemoveAllAmmo()
{
    local FoxPawn P;
    local Inventory Inv;
    local FoxWeapon Weap;

    // End:0x159
    foreach WorldInfo.AllPawns(class'FoxPawn', P)
    {
        Inv = P.InvManager.InventoryChain;
        J0x73:
        // End:0x158 [Loop If]
        if(Inv != none)
        {
            Weap = FoxWeapon(Inv);
            // End:0x12D
            if(Weap != none)
            {
                Weap.AmmoUsedCount = int(Weap.GetMagazineSize());
                Weap.AmmoLeftCount = 0;
                Weap.SpareAmmoCount = 0;
            }
            Inv = Inv.Inventory;
            // [Loop Continue]
            goto J0x73;
        }        
    }    
    //return;    
}

exec function SetPreviewBaseColor(float R, float G, float B)
{
    // End:0x14F
    if(FoxCustomPlayerActor(DynamicUI.Menu.ArmoryInfo.PreviewActor) != none)
    {
        DynamicUI.Menu.ArmoryInfo.PreviewActor.CamoInfo.bUseBaseColor = true;
        FoxCustomPlayerActor(DynamicUI.Menu.ArmoryInfo.PreviewActor).SetBaseColor(R, G, B);
    }
    // End:0x211
    else
    {
        DynamicUI.Menu.PlayerPreviewActor.CamoInfo.bUseBaseColor = true;
        DynamicUI.Menu.PlayerPreviewActor.SetBaseColor(R, G, B);
    }
    //return;    
}

exec function SetPreviewOverlayColor(float R, float G, float B)
{
    // End:0xDC
    if(FoxCustomPlayerActor(DynamicUI.Menu.ArmoryInfo.PreviewActor) != none)
    {
        FoxCustomPlayerActor(DynamicUI.Menu.ArmoryInfo.PreviewActor).SetOverlayColor(R, G, B);
    }
    // End:0x140
    else
    {
        DynamicUI.Menu.PlayerPreviewActor.SetOverlayColor(R, G, B);
    }
    //return;    
}

exec function ArmorySetWeaponXY(int X, int Y)
{
    DynamicUI.Menu.ArmoryInfo.WeaponXPos = X;
    DynamicUI.Menu.ArmoryInfo.WeaponYPos = Y;
    DynamicUI.Menu.ArmoryInfo.PreviewActor.MoveWeaponToIdealPosition(float(DynamicUI.Menu.ArmoryInfo.WeaponXPos), float(DynamicUI.Menu.ArmoryInfo.WeaponYPos), float(DynamicUI.Menu.ArmoryInfo.WeaponWidth), float(DynamicUI.Menu.ArmoryInfo.WeaponHeight));
    //return;    
}

exec function ArmorySetWeaponWH(int X, int Y)
{
    DynamicUI.Menu.ArmoryInfo.WeaponWidth = X;
    DynamicUI.Menu.ArmoryInfo.WeaponHeight = Y;
    DynamicUI.Menu.ArmoryInfo.PreviewActor.MoveWeaponToIdealPosition(float(DynamicUI.Menu.ArmoryInfo.WeaponXPos), float(DynamicUI.Menu.ArmoryInfo.WeaponYPos), float(DynamicUI.Menu.ArmoryInfo.WeaponWidth), float(DynamicUI.Menu.ArmoryInfo.WeaponHeight));
    //return;    
}

simulated event PostBeginPlay()
{
    super.PostBeginPlay();
    AddCheats();
    //return;    
}

exec function Admin(string CommandLine)
{
    ServerAdmin(CommandLine);
    //return;    
}

reliable server function ServerAdmin(string CommandLine)
{
    local string Result;

    Result = ConsoleCommand(CommandLine);
    // End:0x43
    if(Result != "")
    {
        ClientMessage(Result);
    }
    //return;    
}

exec function KickBan(string S)
{
    ServerKickBan(S);
    //return;    
}

reliable server function ServerKickBan(string S)
{
    WorldInfo.Game.KickBan(S);
    //return;    
}

exec function Kick(string S)
{
    ServerKick(S);
    //return;    
}

reliable server function ServerKick(string S)
{
    WorldInfo.Game.Kick(S);
    //return;    
}

exec function PlayerList()
{
    local PlayerReplicationInfo PRI;

    // End:0x1A
    foreach DynamicActors(class'PlayerReplicationInfo', PRI)
    {        
    }    
    //return;    
}

exec function RestartMap()
{
    ServerRestartMap();
    //return;    
}

exec function StartOnlineGame()
{
    OnlineSub.GameInterface.StartOnlineGame('Game');
    //return;    
}

reliable server function ServerRestartMap()
{
    ClientTravel("?restart", 2);
    //return;    
}

exec function Switch(string URL)
{
    ServerSwitch(URL);
    //return;    
}

reliable server function ServerSwitch(string URL)
{
    WorldInfo.ServerTravel(URL);
    //return;    
}

exec function BalanceTeams()
{
    ServerBalanceTeams();
    //return;    
}

reliable server function ServerBalanceTeams()
{
    // End:0x75
    if(WorldInfo.Game.IsA('FoxGameMP_TDM'))
    {
        FoxGameMP_TDM(WorldInfo.Game).BalanceTeams();
    }
    //return;    
}

exec function SpawnAIBotByProviderName(name ProviderName, optional bool bRespawn)
{
    ServerSpawnAIBotByProviderName(ProviderName, bRespawn);
    //return;    
}

reliable server function ServerSpawnAIBotByProviderName(name ProviderName, bool bRespawn)
{
    FoxGame(WorldInfo.Game).SpawnAIBotByProviderName(ProviderName,,,,,, bRespawn, false);
    //return;    
}

exec function SpawnBots(const int Number)
{
    FoxGame(WorldInfo.Game).SpawnRandomBots(Number);
    //return;    
}

exec function SpawnEnemyTurret()
{
    local FoxAIControllerInterface NewController;
    local FoxPawn NewPawn;
    local PlayerStart Start;
    local FoxPRI FoxPRI;
    local int TeamIndex;

    TeamIndex = ((GetTeamNum() == 0) ? 1 : 0);
    NewController = Spawn(class'FoxAIControllerInterface_Turret', none);
    Start = FoxGame(WorldInfo.Game).ChoosePlayerStart(NewController, byte(TeamIndex));
    NewPawn = Spawn(class<FoxPawn>(DynamicLoadObject("FoxGameContent_CHA.FoxPawn_DeployableTurretContent", class'Class')),,, Start.Location, Start.Rotation);
    NewPawn.RotationRate.Yaw = 25000;
    NewPawn.AimOffsetInterpSpeed = 4.0;
    NewController.SetTeam(TeamIndex);
    FoxPRI = FoxPRI(NewController.PlayerReplicationInfo);
    FoxPRI.Loadout.DefaultPawnClass = NewPawn.Class;
    NewController.Possess(NewPawn, false);
    //return;    
}

exec function DumpMaxPlayers()
{
    local FoxGameSettingsCommon GameSettings;
    local int MaxProperty;

    GameSettings = FoxGameSettingsCommon(OnlineSub.GameInterface.GetGameSettings('Game'));
    // End:0x90
    if(GameSettings != none)
    {
        GameSettings.GetIntProperty(268435612, MaxProperty);
        J0x90:
    }
    // End:0x90
    else
    {
    }
    //return;    
}

exec function AddXP(int Exp)
{
    AddExperience(Exp);
    //return;    
}

exec function AddExperience(int Exp)
{
    ServerAddExperience(Exp);
    //return;    
}

reliable server function ServerAddExperience(int Exp)
{
    FoxPRI(PlayerReplicationInfo).AddExperience(Exp);
    WorldInfo.Game.Broadcast(self, ((PlayerReplicationInfo.PlayerName @ "is a dirty cheater. They gave themselves") @ string(Exp)) @ "Experience", 'Say');
    //return;    
}

exec function PlayerPrestiged()
{
    FoxPRI(PlayerReplicationInfo).PlayerPrestiged();
    //return;    
}

exec function LoadoutQuery()
{
    OnlineSub.StoreInterface.LoadoutQuery(FoxPRI(PlayerReplicationInfo).UniqueId);
    //return;    
}

exec function LoadoutCreate()
{
    OnlineSub.StoreInterface.LoadoutCreate(FoxPRI(PlayerReplicationInfo).UniqueId);
    //return;    
}

exec function LoadoutUpdate(string LoadoutId, string LoadoutName)
{
    OnlineSub.StoreInterface.LoadoutUpdate(FoxPRI(PlayerReplicationInfo).UniqueId, LoadoutId, LoadoutName, "t1=500,t2=1200,t3=1600,t4=1800");
    //return;    
}

exec function LoadoutRemove(string LoadoutId)
{
    OnlineSub.StoreInterface.LoadoutRemove(FoxPRI(PlayerReplicationInfo).UniqueId, LoadoutId);
    //return;    
}

exec function LoadoutInstall(string ShareCode)
{
    OnlineSub.StoreInterface.LoadoutInstall(FoxPRI(PlayerReplicationInfo).UniqueId, ShareCode);
    //return;    
}

exec function LoadoutShare(string LoadoutId)
{
    OnlineSub.StoreInterface.LoadoutShare(FoxPRI(PlayerReplicationInfo).UniqueId, LoadoutId);
    //return;    
}

exec function LoadoutClone(string LoadoutId)
{
    OnlineSub.StoreInterface.LoadoutClone(FoxPRI(PlayerReplicationInfo).UniqueId, LoadoutId);
    //return;    
}

exec function LoadoutPicker()
{
    // End:0xB9
    if(((DynamicUI != none) && DynamicUI.Menu != none) && DynamicUI.Menu.ArmoryInfo != none)
    {
        DynamicUI.Menu.ArmoryInfo.ui_OpenLoadoutPicker();
    }
    //return;    
}

exec function LoadoutList()
{
    //return;    
}

exec function LoadoutValidate(string LoadoutId)
{
    local FoxItemCacheLoadouts LoadoutsCache;

    // End:0x53
    if(class'FoxDataStore_StoreData'.static.GetCachedLoadouts(LoadoutsCache))
    {
        LoadoutsCache.IsLoadoutValid(LoadoutId);
    }
    //return;    
}

exec function AddGP(int Amount)
{
    ServerAddGP(Amount);
    //return;    
}

reliable server function ServerAddGP(int Amount)
{
    FoxPRI(PlayerReplicationInfo).AddGamePoints(Amount);
    //return;    
}

exec function AddCP(int Amount)
{
    ServerAddCP(Amount);
    //return;    
}

reliable server function ServerAddCP(int Amount)
{
    FoxPRI(PlayerReplicationInfo).AddCombatPoints(Amount);
    //return;    
}

exec function ForceMap(string MapName)
{
    ServerForceMap(MapName);
    //return;    
}

reliable server function ServerForceMap(string MapName)
{
    local FoxIntermission Intermission;

    Intermission = FoxIntermission(FoxGRI(WorldInfo.GRI).GameFlow);
    // End:0xCA
    if(Intermission != none)
    {
        Intermission.ForcedMapIndex = GetMenuItemsDataStore().GetMapIndex(MapName);
        // End:0xCA
        if(Intermission.ForcedMapIndex >= 0)
        {
        }
    }
    //return;    
}

exec function ForceGame(string GameMode)
{
    local class<FoxGame> NewGameClass;

    // End:0x28
    if(GameMode ~= "DM")
    {
        NewGameClass = class'FoxGameMP_DM';
    }
    // End:0xCC
    else
    {
        // End:0x51
        if(GameMode ~= "TDM")
        {
            NewGameClass = class'FoxGameMP_TDM';
        }
        // End:0xCC
        else
        {
            // End:0x8E
            if((GameMode ~= "DOM") || GameMode ~= "CP")
            {
                NewGameClass = class'FoxGameMP_CP';
            }
            // End:0xCC
            else
            {
                // End:0xCC
                if((GameMode ~= "KOTH") || GameMode ~= "TKOTH")
                {
                    NewGameClass = class'FoxGameMP_TKOTH';
                }
            }
        }
    }
    // End:0xDE
    if(NewGameClass != none)
    {
        J0xDE:
    }
    // End:0xDE
    else
    {
    }
    ServerForceGame(NewGameClass);
    //return;    
}

reliable server function ServerForceGame(class<FoxGame> NewGameClass)
{
    WorldInfo.NextGameClass = NewGameClass;
    //return;    
}

exec function EndMenuTimer()
{
    EndIntermission();
    //return;    
}

exec function EndIntermission()
{
    // End:0x99
    if((FoxGRI(WorldInfo.GRI).GameFlow != none) && FoxIntermission(FoxGRI(WorldInfo.GRI).GameFlow) != none)
    {
        ServerEndIntermission();
    }
    //return;    
}

reliable server function ServerEndIntermission()
{
    local FoxIntermission Intermission;
    local FoxPC ForPC;

    Intermission = FoxIntermission(FoxGRI(WorldInfo.GRI).GameFlow);
    // End:0x108
    if(Intermission != none)
    {
        // End:0xC9
        foreach WorldInfo.AllControllers(class'FoxPC', ForPC)
        {
            ForPC.PlayerReplicationInfo.bReadyToPlay = true;            
        }        
        Intermission.CloseMapSkipVoting();
        Intermission.GameReadyToStart();
    }
    //return;    
}

exec function PlaylistSkip()
{
    ServerForcePlaylistSkip();
    //return;    
}

reliable server function ServerForcePlaylistSkip()
{
    local FoxIntermission Intermission;

    Intermission = FoxIntermission(FoxGRI(WorldInfo.GRI).GameFlow);
    // End:0x7D
    if(Intermission != none)
    {
        Intermission.SetMapIndex();
    }
    //return;    
}

exec function DebugBind(name Key)
{
    //return;    
}

exec function ForceEndGame()
{
    // End:0x99
    if((FoxGRI(WorldInfo.GRI).GameFlow == none) || FoxIntermission(FoxGRI(WorldInfo.GRI).GameFlow) == none)
    {
        ServerForceEndGame();
    }
    //return;    
}

exec function EndRound()
{
    ForceEndRound();
    //return;    
}

exec function ForceEndRound()
{
    // End:0x99
    if((FoxGRI(WorldInfo.GRI).GameFlow == none) || FoxIntermission(FoxGRI(WorldInfo.GRI).GameFlow) == none)
    {
        ServerForceEndRound();
    }
    //return;    
}

reliable server function ServerForceEndGame()
{
    WorldInfo.Game.EndGame(PlayerReplicationInfo, "Force ended game");
    //return;    
}

reliable server function ServerForceEndRound()
{
    WorldInfo.GRI.RemainingTime = 0;
    FoxGame(WorldInfo.Game).EndRound();
    //return;    
}

exec function KillGameAndRollover()
{
    ServerKillGameAndRollover();
    //return;    
}

reliable server function ServerKillGameAndRollover()
{
    OnlineSub.GameInterfaceEx.RequestKillServer("Admin Rollover", true);
    //return;    
}

exec function ChangeOnlineDebugLevel(int DebugLevel)
{
    // End:0x37
    if(OnlineSub != none)
    {
        OnlineSub.SetDebugSpewLevel(DebugLevel);
    }
    //return;    
}

exec function TryChangeName()
{
    StartNameChange();
    //return;    
}

exec function SetAdminName(string NewAdminName)
{
    ServerSetAdminName(NewAdminName);
    //return;    
}

reliable server function ServerSetAdminName(string NewAdminName)
{
    FoxGRI(WorldInfo.GRI).ApplyAdminName(NewAdminName);
    //return;    
}

reliable server function ServerAdminSpectate()
{
    // End:0x54
    if(IsInState('CameraMode'))
    {
        Possess(ScreenshotModeOldPawn, false);
        MyFoxPawn.RestoreMeshVisibility();
        GotoState('PlayerWalking');
    }
    // End:0xB6
    else
    {
        MyFoxPawn.SetMeshVisibility(1);
        IgnoreMoveInput(false);
        IgnoreLookInput(false);
        ScreenshotModeOldPawn = Pawn;
        UnPossess();
        GotoState('CameraMode');
    }
    //return;    
}

exec function AdminSpectate()
{
    ServerAdminSpectate();
    // End:0xB2
    if(IsLocalPlayerController())
    {
        MyFoxHud.ToggleHUD();
        // End:0x68
        if(IsInState('CameraMode'))
        {
            MyFoxPawn.RestoreMeshVisibility();
        }
        // End:0xB2
        else
        {
            MyFoxPawn.SetMeshVisibility(1);
            IgnoreMoveInput(false);
            IgnoreLookInput(false);
            ScreenshotModeOldPawn = Pawn;
        }
    }
    //return;    
}

exec function ShowCollision()
{
    ConsoleCommand("show collision");
    MyFoxPawn.RestoreMeshVisibility();
    //return;    
}

exec function LookAtMe()
{
    local FoxPawn HitPawn;

    HitPawn = GetPawnUnderCrosshair();
    // End:0x80
    if(HitPawn != none)
    {
        FoxAIControllerInterface(HitPawn.Controller).LookAt(Pawn.Location, 10);
    }
    //return;    
}

exec function HurtSelf(int Amount)
{
    Pawn.Health -= Amount;
    //return;    
}

exec function ScreenshotMode()
{
    CheatManager.PlayersOnly();
    myHUD.ToggleHUD();
    // End:0x92
    if(IsInState('CameraMode'))
    {
        MyFoxPawn.RestoreMeshVisibility();
        Possess(ScreenshotModeOldPawn, false);
        GotoState('PlayerWalking');
    }
    // End:0xF4
    else
    {
        MyFoxPawn.SetMeshVisibility(1);
        IgnoreMoveInput(false);
        IgnoreLookInput(false);
        ScreenshotModeOldPawn = Pawn;
        UnPossess();
        GotoState('CameraMode');
    }
    //return;    
}

simulated exec function ChangePreset(const coerce string NewPreset)
{
    ServerChangePreset(NewPreset);
    //return;    
}

exec function ChangeDepotPreset(const coerce string NewDepotPreset)
{
    local FoxWeapon NewWeaponInventory;
    local FoxDepotPresetInfo PresetInfo;
    local FoxWeaponConfigInfo WeaponConfig;

    // End:0x29
    if(Role < ROLE_Authority)
    {
        ServerChangeDepotPreset(NewDepotPreset);
        return;
    }
    class'FoxUnlockInfo'.static.GetDepotPresetFromName(NewDepotPreset, PresetInfo);
    class'FoxUnlockInfo'.static.GetDepotPresetClasses(PresetInfo, WeaponConfig.WeaponClass, WeaponConfig.WeaponBarrel, WeaponConfig.WeaponMuzzle, WeaponConfig.WeaponScope, WeaponConfig.WeaponStock, WeaponConfig.WeaponMagazine, WeaponConfig.WeaponGrip, WeaponConfig.WeaponAmmo);
    NewWeaponInventory = Spawn(WeaponConfig.WeaponClass);
    GetLoadoutInfo().SetCurrentWeaponConfig(1, WeaponConfig);
    NewWeaponInventory.GiveTo(Pawn);
    //return;    
}

reliable server function ServerChangeDepotPreset(const coerce string NewDepotPreset)
{
    ChangeDepotPreset(NewDepotPreset);
    //return;    
}

protected reliable server function ServerChangePreset(const coerce string NewPreset)
{
    local class<FoxWeapon> NewWeaponClass;
    local FoxWeapon Inventory;

    NewWeaponClass = FoxPRI(PlayerReplicationInfo).Loadout.SetCurrentConfigToPreset(NewPreset);
    // End:0x10A
    if(((NewWeaponClass != none) && Pawn != none) && Pawn.IsAliveAndWell())
    {
        Inventory = Spawn(NewWeaponClass);
        Inventory.GiveTo(Pawn);
        Inventory.AnnouncePickup(Pawn);
        J0x10A:
    }
    // End:0x10A
    else
    {
    }
    //return;    
}

exec function SwitchLevel(string URL)
{
    // End:0x102
    if((WorldInfo.NetMode == NM_Standalone) || WorldInfo.NetMode == NM_ListenServer)
    {
        MyFoxHud.DestroyHud();
        UnLoadSoundBanks();
        WorldInfo.Game.Broadcast(none, "Admin is changing the level", 'AdminMessage');
        WorldInfo.ServerTravel(URL);
    }
    //return;    
}

reliable client simulated function ClientDebugHost(string Host, string BackupHost)
{
    //return;    
}

exec function DebugSignIn()
{
    //return;    
}

exec function KickPlayers()
{
    ServerKickPlayers();
    //return;    
}

reliable server function ServerKickPlayers()
{
    local FoxPC PC;

    // End:0x94
    foreach WorldInfo.AllControllers(class'FoxPC', PC)
    {
        // End:0x93
        if(PC.PlayerReplicationInfo.PlayerName ~= "Player")
        {
            PC.ClientKickedForIdle();
        }        
    }    
    //return;    
}

exec function KickSelf(optional string Message)
{
    // End:0x27
    if(Message != "")
    {
        ClientWasKicked(Message);
    }
    // End:0x3E
    else
    {
        ClientWasKicked("Kicked self");
    }
    //return;    
}

exec function DebugPlayers()
{
    OnlineSub.GameInterface.AddGetNumberOfCurrentPlayersCompleteDelegate(OnGetNumberOfCurrentPlayersComplete);
    OnlineSub.GameInterface.GetNumberOfCurrentPlayers();
    //return;    
}

exec function SetPlayerHealth(int Health)
{
    Pawn.Health = Health;
    //return;    
}

exec function FOV(float F)
{
    // End:0x22
    if(CheatManager != none)
    {
        super(PlayerController).FOV(F);
    }
    //return;    
}

exec function BeginStreamAlleyWay()
{
    ServerStreamAlleyWay();
    //return;    
}

reliable server function ServerStreamAlleyWay()
{
    local array<name> LevelNames;

    LevelNames.AddItem('AlleyWay');
    LevelNames.AddItem('AlleyWayAI');
    LevelNames.AddItem('AlleyWayAudio');
    BeginTheStream(LevelNames);
    //return;    
}

exec function BeginStreamHardSuit()
{
    ServerStreamHardSuit();
    //return;    
}

reliable server function ServerStreamHardSuit()
{
    local array<name> LevelNames;

    LevelNames.AddItem('HardSuitTest');
    BeginTheStream(LevelNames);
    //return;    
}

exec function BeginStreamSlumlord()
{
    ServerStreamSlumlord();
    //return;    
}

reliable server function ServerStreamSlumlord()
{
    local array<name> LevelNames;

    LevelNames.AddItem('Slumlord');
    BeginTheStream(LevelNames);
    //return;    
}

exec function BeginStreamFoxEntry()
{
    ServerStreamFoxEntry();
    //return;    
}

reliable server function ServerStreamFoxEntry()
{
    local array<name> LevelNames;

    LevelNames.AddItem('FoxEntry');
    BeginTheStream(LevelNames);
    //return;    
}

function BeginTheStream(array<name> LevelNames)
{
    local FoxPC PC;
    local int I;

    WorldInfo.PrepareMapChange(LevelNames);
    WorldInfo.CommitMapChange();
    // End:0x146
    foreach WorldInfo.AllControllers(class'FoxPC', PC)
    {
        // End:0x145
        if(!PC.IsLocalPlayerController())
        {
            I = 0;
            J0xAA:
            // End:0x126 [Loop If]
            if(I < LevelNames.Length)
            {
                PC.ClientPrepareMapChange(LevelNames[I], I == 0, I == (LevelNames.Length - 1));
                ++ I;
                // [Loop Continue]
                goto J0xAA;
            }
            PC.ClientCommitMapChange();
        }        
    }    
    //return;    
}

reliable server function ServerUnloadStreams()
{
    FoxGame(WorldInfo.Game).UnloadStreams();
    //return;    
}

exec function UnloadStreams()
{
    ServerUnloadStreams();
    //return;    
}

exec function ForcePlaylistByName(name playlistName)
{
    ServerSetPlaylistByName(playlistName);
    //return;    
}

reliable server function ServerSetPlaylistByName(name playlistName)
{
    GetPlaylistsDataStore().SelectPlaylistByName(playlistName);
    FoxGRI(WorldInfo.GRI).NextNextMapIndex = byte(GetMenuItemsDataStore().GetMapIndex(GetPlaylistsDataStore().GetPlaylistNextMapName()));
    FoxGRI(WorldInfo.GRI).NextGameClass = GetPlaylistsDataStore().GetNextGameClass();
    // End:0x1BE
    if(((DynamicUI != none) && DynamicUI.Menu != none) && DynamicUI.Menu.Lobby != none)
    {
        DynamicUI.Menu.Lobby.UpdateLobbyInfo();
    }
    //return;    
}

exec function CyclePlaylist()
{
    GetPlaylistsDataStore().CyclePlaylist();
    //return;    
}

exec function PWLogin(const string User, const string pass)
{
    OnlineSub.PlayerInterface.Login(0, User, pass, false);
    //return;    
}

exec function PWGPAdd(const int Amount)
{
    OnlineSub.StoreInterface.AddGP(PlayerReplicationInfo.UniqueId, Amount);
    //return;    
}

exec function PWConsumeItem(const int ItemId, const int ConsumeAmount, optional bool bStrict)
{
    local UniqueNetId LoggedInPlayerId;

    OnlineSub.PlayerInterface.GetUniquePlayerId(0, LoggedInPlayerId);
    OnlineSub.StoreInterface.ConsumeItemByID(LoggedInPlayerId, ItemId, ConsumeAmount, bStrict);
    //return;    
}

exec function PWFundQuery()
{
    OnlineSub.StoreInterface.QueryFunds(PlayerReplicationInfo.UniqueId);
    //return;    
}

exec function PWCreateCustomGame(string ServerName, string Password, string Playlist)
{
    local FoxGameSettingsCommon NewSettings;

    NewSettings = new class'FoxGameSettingsCommon';
    OnlineSub.GameInterface.CreateOnlineGame(0, 'CustomGame', NewSettings);
    //return;    
}

exec function PWAddXP(int Amount)
{
    OnlineSub.StoreInterface.AddXP(PlayerReplicationInfo.UniqueId, Amount);
    //return;    
}

exec function PWGetXP()
{
    OnlineSub.StoreInterface.QueryXP(PlayerReplicationInfo.UniqueId);
    //return;    
}

exec function KillServer(string Reason, bool bClone)
{
    ServerKillServer(Reason, bClone);
    //return;    
}

reliable server function ServerKillServer(string Reason, bool bClone)
{
    OnlineSub.GameInterfaceEx.RequestKillServer(Reason, bClone);
    //return;    
}

exec function DebugUseObject()
{
    // End:0x19
    if(MyFoxPawn != none)
    {
        ServerGetUseObject();
    }
    //return;    
}

reliable server function ServerGetUseObject()
{
    // End:0x37
    if(MyFoxPawn != none)
    {
        ClientGiveUseObject(MyFoxPawn.NearbyUseObject);
    }
    //return;    
}

reliable client simulated function ClientGiveUseObject(FoxGameObject UseObject)
{
    //return;    
}

exec function ApplyItem(int ItemId)
{
    ServerApplyItem(ItemId);
    // End:0x95
    if(WorldInfo.NetMode == NM_Client)
    {
        FoxServerConnection(WorldInfo.ServerConn).ApplyActivatedItem(FoxPRI(PlayerReplicationInfo), ItemId);
    }
    //return;    
}

reliable server function ServerApplyItem(int ItemId)
{
    FoxServerConnection(WorldInfo.ServerConn).ApplyActivatedItem(FoxPRI(PlayerReplicationInfo), ItemId);
    //return;    
}

exec function AddToTeamScore(int Amount)
{
    ServerAddToTeamScore(Amount);
    //return;    
}

reliable server function ServerAddToTeamScore(int Amount)
{
    PlayerReplicationInfo.Team.Score += float(Amount);
    //return;    
}

exec function God()
{
    ServerGodMode();
    //return;    
}

reliable server function ServerGodMode()
{
    // End:0x35
    if(bGodMode)
    {
        bGodMode = false;
        ClientMessage("God mode off");
        return;
    }
    bGodMode = true;
    ClientMessage("God Mode on");
    //return;    
}

exec function DebugRot()
{
    //return;    
}

exec function ForceRot()
{
    SetRotation(rot(0, 0, 0));
    //return;    
}

exec function PrintActorInfo()
{
    local Pawn P;

    // End:0x52
    foreach DynamicActors(class'Pawn', P)
    {
        // End:0x51
        if(Role == ROLE_Authority)
        {
            // End:0x51
            if(P.PlayerReplicationInfo != none)
            {
            }
        }        
    }    
    //return;    
}

exec function SetRank(int NewRankIndex)
{
    ServerSetRank(NewRankIndex);
    //return;    
}

reliable server function ServerSetRank(int NewRankIndex)
{
    // End:0xA4
    if((NewRankIndex > 0) && NewRankIndex <= class'FoxUnlockInfo'.default.RankData.Length)
    {
        FoxPRI(PlayerReplicationInfo).SetInitialXP(class'FoxUnlockInfo'.default.RankData[NewRankIndex - 1].RankScore);
    }
    //return;    
}

exec function ChangeUpperBody(int Index)
{
    ServerChangeUpperBody(Index);
    //return;    
}

reliable server function ServerChangeUpperBody(int Index)
{
    FoxPRI(PlayerReplicationInfo).Loadout.ChangeUpperBody(Index);
    //return;    
}

exec function ChangeLowerBody(int Index)
{
    ServerChangeLowerBody(Index);
    //return;    
}

reliable server function ServerChangeLowerBody(int Index)
{
    FoxPRI(PlayerReplicationInfo).Loadout.ChangeLowerBody(Index);
    //return;    
}

exec function ChangeHelmet(int Index)
{
    ServerChangeHelmet(Index);
    //return;    
}

reliable server function ServerChangeHelmet(int Index)
{
    FoxPRI(PlayerReplicationInfo).Loadout.ChangeHelmet(Index);
    //return;    
}

exec function DebugUnlock(int UnlockID)
{
    local string FriendlyName, Description, IconRef;

    class'FoxUnlockInfo'.static.GetUnlockInfoFromID(UnlockID, FriendlyName, IconRef, Description);
    //return;    
}

exec function DebugRevive()
{
    ServerDebugRevive();
    ClearTimer('SpectateCorpseTimerExpire');
    ClearTimer('KillCamTimerExpire');
    ClearTimer('TriggerRespawn');
    //return;    
}

reliable server function ServerDebugRevive()
{
    local Pawn PawnTemp;

    // End:0xF4
    if((MyDeadPawn != none) && MyDeadPawn.IsInjured())
    {
        ClearTimer('SpectateCorpseTimerExpire');
        ClearTimer('KillCamTimerExpire');
        ClearTimer('TriggerRespawn');
        PawnTemp = MyDeadPawn;
        MyDeadPawn = none;
        Possess(PawnTemp, false);
        EnterStartState();
        ResetRevengeList();
        SetCameraMode('FirstPerson');
        FoxPawn(Pawn).DoSpecialMove(7);
    }
    //return;    
}

exec function SetCrosshair(int NumTicks, int TickLength, bool bRotated)
{
    CrosshairOverride.NumTicks = NumTicks;
    CrosshairOverride.TickLength = float(TickLength);
    CrosshairOverride.bIsRotated = bRotated;
    MyFoxHud.DynamicUI.HUD.NotifyWeaponChange(MyFoxPawn.MyFoxWeapon);
    //return;    
}

exec function ChangeCrosshair(int DataStoreIndex)
{
    local FoxDataStore_Unlockables DataStore;
    local FoxDataProvider_Crosshairs Provider;

    // End:0x22
    if(DataStoreIndex == -1)
    {
        bUseCrosshairOverride = false;
    }
    // End:0x18E
    else
    {
        DataStore = FoxDataStore_Unlockables(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxUnlockables'));
        Provider = FoxDataProvider_Crosshairs(DataStore.CrosshairProviderArray[DataStoreIndex]);
        // End:0x182
        if(Provider != none)
        {
            CrosshairOverride.NumTicks = Provider.NumTicks;
            CrosshairOverride.TickLength = float(Provider.TickLength);
            CrosshairOverride.bIsRotated = Provider.bRotated;
            bUseCrosshairOverride = true;
        }
        // End:0x18E
        else
        {
            bUseCrosshairOverride = false;
        }
    }
    //return;    
}

exec function TestHeros()
{
    local array<FoxHeroPoseActor> MyHeroArray;
    local FoxPRI PlayerRep;
    local int I;
    local FoxMapInfo MapInfo;

    MapInfo = FoxMapInfo(WorldInfo.GetMapInfo());
    ++ MapInfo.SelectedHeroCameraIndex;
    // End:0xB7
    if(MapInfo.SelectedHeroCameraIndex >= MapInfo.HeroPoseCameras.Length)
    {
        MapInfo.SelectedHeroCameraIndex = 0;
    }
    SwitchToHeroPoseCamera();
    // End:0x2AB
    if(WorldInfo.NetMode != NM_DedicatedServer)
    {
        PlayerRep = FoxPRI(PlayerReplicationInfo);
        RefreshLoadout();
        MyHeroArray = MapInfo.GetSelectedHeroCamera().HeroActors;
        I = 0;
        J0x15A:
        // End:0x2AB [Loop If]
        if(I < MyHeroArray.Length)
        {
            // End:0x1D5
            if(MyHeroArray[I].PlayerRank == 1)
            {
                MyHeroArray[I].HeroAnimName = 'Hero_Idle_A';
            }
            // End:0x26B
            else
            {
                // End:0x239
                if(MyHeroArray[I].PlayerRank == 2)
                {
                    MyHeroArray[I].HeroAnimName = 'Hero_Idle_B';
                }
                // End:0x26B
                else
                {
                    MyHeroArray[I].HeroAnimName = 'Hero_Idle_C';
                }
            }
            MyHeroArray[I].SetPRI(PlayerRep);
            ++ I;
            // [Loop Continue]
            goto J0x15A;
        }
    }
    //return;    
}

exec function ChangeScope(string ScopeClassName, optional bool bPrimary)
{
    local FoxLoadoutInfo Loadout;

    bPrimary = true;
    Loadout = FoxPRI(PlayerReplicationInfo).Loadout;
    // End:0xF5
    if(true == Loadout.ChangeCurrentScope(0, ScopeClassName))
    {
        // End:0xF5
        if(MyFoxPawn != none)
        {
            // End:0xD6
            if(MyFoxPawn.MyFoxWeapon != none)
            {
                MyFoxPawn.AttachWeapon(MyFoxPawn.MyFoxWeapon);
            }
            MyFoxPawn.UpdateWeaponAttachmentMods();
        }
    }
    //return;    
}

exec function ChangePrimaryMod(string ModClassName)
{
    local bool bSuccess;

    bSuccess = FoxPRI(PlayerReplicationInfo).Loadout.TryChangeCurrentModByName(ModClassName, true);
    // End:0xEE
    if(bSuccess)
    {
        // End:0xEE
        if(MyFoxPawn != none)
        {
            // End:0xCF
            if(MyFoxPawn.MyFoxWeapon != none)
            {
                MyFoxPawn.AttachWeapon(MyFoxPawn.MyFoxWeapon);
            }
            MyFoxPawn.UpdateWeaponAttachmentMods();
        }
    }
    //return;    
}

exec function ChangeSecondaryMod(string ModClassName)
{
    local bool bSuccess;

    bSuccess = FoxPRI(PlayerReplicationInfo).Loadout.TryChangeCurrentModByName(ModClassName, false);
    // End:0xEE
    if(bSuccess)
    {
        // End:0xEE
        if(MyFoxPawn != none)
        {
            // End:0xCF
            if(MyFoxPawn.MyFoxWeapon != none)
            {
                MyFoxPawn.AttachWeapon(MyFoxPawn.MyFoxWeapon);
            }
            MyFoxPawn.UpdateWeaponAttachmentMods();
        }
    }
    //return;    
}

exec function ChangeMagazine(string MagazineClassName, optional bool bPrimary)
{
    local FoxLoadoutInfo Loadout;

    bPrimary = true;
    Loadout = FoxPRI(PlayerReplicationInfo).Loadout;
    // End:0x106
    if(true == Loadout.ChangeCurrentMagazine(((bPrimary) ? 0 : 1), MagazineClassName))
    {
        // End:0x106
        if(MyFoxPawn != none)
        {
            // End:0xE7
            if(MyFoxPawn.MyFoxWeapon != none)
            {
                MyFoxPawn.AttachWeapon(MyFoxPawn.MyFoxWeapon);
            }
            MyFoxPawn.UpdateWeaponAttachmentMods();
        }
    }
    //return;    
}

exec function ChangeHangerIndex(int Index)
{
    local FoxLoadoutInfo Loadout;

    Loadout = FoxPRI(PlayerReplicationInfo).Loadout;
    // End:0xEE
    if(true == Loadout.ChangeHangerIndex(Index))
    {
        // End:0xEE
        if(MyFoxPawn != none)
        {
            // End:0xCF
            if(MyFoxPawn.MyFoxWeapon != none)
            {
                MyFoxPawn.AttachWeapon(MyFoxPawn.MyFoxWeapon);
            }
            MyFoxPawn.UpdateWeaponAttachmentMods();
        }
    }
    //return;    
}

exec function ChangeAmmoType(int AmmoType, optional bool bPrimary)
{
    local FoxLoadoutInfo Loadout;

    bPrimary = true;
    Loadout = FoxPRI(PlayerReplicationInfo).Loadout;
    // End:0xF5
    if(true == Loadout.ChangeAmmoType(0, AmmoType))
    {
        // End:0xF5
        if(MyFoxPawn != none)
        {
            // End:0xD6
            if(MyFoxPawn.MyFoxWeapon != none)
            {
                MyFoxPawn.AttachWeapon(MyFoxPawn.MyFoxWeapon);
            }
            MyFoxPawn.UpdateWeaponAttachmentMods();
        }
    }
    //return;    
}

exec function DebugChangeTeams()
{
    ServerDebugChangeTeams();
    //return;    
}

reliable server function ServerDebugChangeTeams()
{
    //return;    
}

exec function GiveGear(int Index)
{
    local FoxDataProvider_Gear_Attachment NewGear;
    local FoxLoadoutInfo Loadout;
    local class<FoxWeapon> WeaponClassToAdd;
    local FoxWeapon NewWeapon;

    // End:0x2A
    if(Role < ROLE_Authority)
    {
        ServerGiveGear(Index);
    }
    // End:0x179
    else
    {
        Loadout = FoxPRI(PlayerReplicationInfo).Loadout;
        NewGear = FoxDataProvider_Gear_Attachment(Loadout.UnlockablesDataStore.AttachmentProviderArray[Index]);
        WeaponClassToAdd = class<FoxWeapon>(Loadout.ResolveWpnContentByName(NewGear.WeaponClassName));
        // End:0x179
        if(MyFoxPawn != none)
        {
            NewWeapon = FoxWeapon(MyFoxPawn.AddInventory(WeaponClassToAdd));
            NewWeapon.SetGearInfo(NewGear, byte(Index));
        }
    }
    //return;    
}

reliable server function ServerGiveGear(int Index)
{
    GiveGear(Index);
    //return;    
}

exec function CheckLoadoutInfo()
{
    FoxPRI(PlayerReplicationInfo).Loadout.ValidityCheckLoadoutInfo();
    //return;    
}

exec function DebugSortedPRIs()
{
    local array<FoxPRI> Team1PRIs, Team2PRIs;
    local int I;

    Team1PRIs = FoxGRI(WorldInfo.GRI).GetSortedPRIs(0);
    I = 0;
    J0x55:
    // End:0x7B [Loop If]
    if(I < Team1PRIs.Length)
    {
        ++ I;
        // [Loop Continue]
        goto J0x55;
    }
    Team2PRIs = FoxGRI(WorldInfo.GRI).GetSortedPRIs(1);
    I = 0;
    J0xD0:
    // End:0xF6 [Loop If]
    if(I < Team2PRIs.Length)
    {
        ++ I;
        // [Loop Continue]
        goto J0xD0;
    }
    //return;    
}

exec function Electrify()
{
    // End:0x21
    if(Role < ROLE_Authority)
    {
        ServerElectrify();
    }
    // End:0x5E
    else
    {
        MyFoxPawn.SetElectrified(MyFoxPawn.HealthMax);
    }
    //return;    
}

exec function StunSelf(float Duration, bool bFriendly)
{
    ServerStunSelf(Duration, bFriendly);
    //return;    
}

reliable server function ServerStunSelf(float Duration, bool bFriendly)
{
    MyFoxPawn.NotifyStunned(Duration, bFriendly);
    //return;    
}

exec function QueryStore()
{
    OnlineSub.StoreInterface.QueryStore();
    //return;    
}

exec function QueryInventory()
{
    OnlineSub.StoreInterface.QueryInventory(OnlineSub.GetPlayerUniqueNetIdFromIndex(0));
    //return;    
}

exec function MailQuery()
{
    OnlineSub.StoreInterface.QueryMail();
    //return;    
}

exec function MailSend(string UserName, string Subject, string Message, int GPAmount)
{
    OnlineSub.StoreInterface.SendMail(UserName, Subject, Message, "", "", "", "", GPAmount, 0);
    //return;    
}

exec function MailRead(int MailIndex)
{
    local FoxItemCacheMail MailCache;
    local array<MailMetaData> MailItems;

    // End:0xD8
    if(class'FoxDataStore_StoreData'.static.GetCachedMail(MailCache))
    {
        MailItems = MailCache.GetMail();
        // End:0xD8
        if((MailIndex >= 0) && MailIndex < MailItems.Length)
        {
            OnlineSub.StoreInterface.MarkMailRead(MailItems[MailIndex].UniqueId);
        }
    }
    //return;    
}

exec function MailOpen(int MailIndex)
{
    local FoxItemCacheMail MailCache;
    local array<MailMetaData> MailItems;

    // End:0xD8
    if(class'FoxDataStore_StoreData'.static.GetCachedMail(MailCache))
    {
        MailItems = MailCache.GetMail();
        // End:0xD8
        if((MailIndex >= 0) && MailIndex < MailItems.Length)
        {
            OnlineSub.StoreInterface.OpenMail(MailItems[MailIndex].UniqueId);
        }
    }
    //return;    
}

exec function MailDestroy(int MailIndex)
{
    local FoxItemCacheMail MailCache;
    local array<MailMetaData> MailItems;

    // End:0xD8
    if(class'FoxDataStore_StoreData'.static.GetCachedMail(MailCache))
    {
        MailItems = MailCache.GetMail();
        // End:0xD8
        if((MailIndex >= 0) && MailIndex < MailItems.Length)
        {
            OnlineSub.StoreInterface.DestroyMail(MailItems[MailIndex].UniqueId);
        }
    }
    //return;    
}

reliable server function ServerElectrify()
{
    SetTimer(3.0, false, 'Electrify');
    //return;    
}

function DebugInjure()
{
    local Vector ZeroVec;

    // End:0x82
    if(Role == ROLE_Authority)
    {
        Pawn.TakeDamage(200, none, ZeroVec, ZeroVec, MyFoxPawn.MyFoxWeapon.InstantHitDamageTypes[0]);
    }
    // End:0x8C
    else
    {
        ServerDebugInjure();
    }
    //return;    
}

exec function InjurePawn()
{
    ServerDebugInjure();
    //return;    
}

reliable server function ServerDebugInjure()
{
    DebugInjure();
    //return;    
}

exec function GiveTactical(int Index)
{
    local FoxDataProvider_Gear_Attachment NewGear;
    local FoxLoadoutInfo Loadout;
    local class<FoxWeapon> WeaponClassToAdd;

    // End:0x2A
    if(Role < ROLE_Authority)
    {
        ServerGiveTactical(Index);
    }
    // End:0x133
    else
    {
        Loadout = FoxPRI(PlayerReplicationInfo).Loadout;
        NewGear = FoxDataProvider_Gear_Attachment(Loadout.UnlockablesDataStore.TacticalProviderArray[Index]);
        WeaponClassToAdd = class<FoxWeapon>(Loadout.ResolveWpnContentByName(NewGear.WeaponClassName));
        // End:0x133
        if(MyFoxPawn != none)
        {
            MyFoxPawn.AddInventory(WeaponClassToAdd);
        }
    }
    //return;    
}

reliable server function ServerGiveTactical(int Index)
{
    GiveTactical(Index);
    MyFoxPawn.GearInfo.TacticalID = byte(Index);
    //return;    
}

exec function DebugState()
{
    //return;    
}

exec function MyTeamNum()
{
    //return;    
}

exec function TweakAccuracySlider(int NewValue)
{
    FoxCheatManager(CheatManager).InfiniteAmmo();
    MyFoxPawn.MyFoxWeapon.CoalescedWeaponModInfo.Accuracy = NewValue;
    MyFoxPawn.MyFoxWeapon.ApplyAccuracy();
    //return;    
}

exec function TweakRecoilSlider(int NewValue)
{
    FoxCheatManager(CheatManager).InfiniteAmmo();
    MyFoxPawn.MyFoxWeapon.CoalescedWeaponModInfo.Recoil = NewValue;
    MyFoxPawn.MyFoxWeapon.ApplyRecoil();
    //return;    
}

exec function TweakBaseSpread(float NewValue)
{
    FoxCheatManager(CheatManager).InfiniteAmmo();
    MyFoxPawn.MyFoxWeapon.BaseSpread[0] = NewValue;
    //return;    
}

exec function TweakSpreadPerShot(float NewValue)
{
    FoxCheatManager(CheatManager).InfiniteAmmo();
    MyFoxPawn.MyFoxWeapon.SpreadPerShot = NewValue;
    //return;    
}

exec function TweakSpreadPerShotExp(float NewValue)
{
    FoxCheatManager(CheatManager).InfiniteAmmo();
    MyFoxPawn.MyFoxWeapon.SpreadPerShotExp = NewValue;
    //return;    
}

exec function TweakMaximumSpread(float NewValue)
{
    FoxCheatManager(CheatManager).InfiniteAmmo();
    MyFoxPawn.MyFoxWeapon.MaximumSpread = NewValue;
    //return;    
}

exec function TweakRecoilSizeModifier(float NewValue)
{
    FoxCheatManager(CheatManager).InfiniteAmmo();
    MyFoxPawn.MyFoxWeapon.RecoilSizeModifier = NewValue;
    //return;    
}

exec function TweakSpreadShotCountDecayRate(float NewValue)
{
    FoxCheatManager(CheatManager).InfiniteAmmo();
    MyFoxPawn.MyFoxWeapon.SpreadShotCountDecayRate = int(NewValue);
    //return;    
}

exec function TweakSpeed(float NewValue)
{
    FoxCheatManager(CheatManager).InfiniteAmmo();
    MyFoxPawn.GroundSpeed = NewValue;
    //return;    
}

exec function TweakReloadSpeed(float NewValue)
{
    MyFoxPawn.MyFoxWeapon.WeaponReloadRate = NewValue;
    //return;    
}

exec function TweakWeaponSwitchRate(float NewValue)
{
    MyFoxPawn.WeaponSwitchRate = NewValue;
    //return;    
}

exec function TweakDamage(int NewValue)
{
    MyFoxPawn.MyFoxWeapon.InstantHitDamage[0] = float(NewValue);
    //return;    
}

exec function TestAdminMessage(string l1, string l2, string l3, bool bShowTimer)
{
    DisplayAdminMessage(l1, l2, l3, true, bShowTimer);
    //return;    
}

exec function TestBadConnection()
{
    DynamicUI.HUD.ShowBadConnectionIcon();
    //return;    
}

exec function TestDOFKernalSize(float NewSize)
{
    MyFoxPawn.MyFoxWeapon.bDebug = true;
    MyFoxPawn.MyFoxWeapon.ScopeMod.ScopePPSettings.DOF_BlurKernelSize = NewSize;
    //return;    
}

exec function TestDOFMaxNearBlur(float NewSize)
{
    MyFoxPawn.MyFoxWeapon.bDebug = true;
    MyFoxPawn.MyFoxWeapon.ScopeMod.ScopePPSettings.DOF_MaxNearBlurAmount = NewSize;
    //return;    
}

exec function TestDOFMaxFarBlur(float NewSize)
{
    MyFoxPawn.MyFoxWeapon.bDebug = true;
    MyFoxPawn.MyFoxWeapon.ScopeMod.ScopePPSettings.DOF_MaxFarBlurAmount = NewSize;
    //return;    
}

exec function TestDOFInnerRadius(float NewSize)
{
    MyFoxPawn.MyFoxWeapon.bDebug = true;
    MyFoxPawn.MyFoxWeapon.ScopeMod.ScopePPSettings.DOF_FocusInnerRadius = NewSize;
    //return;    
}

exec function TestDOFFalloffExponent(float NewSize)
{
    MyFoxPawn.MyFoxWeapon.bDebug = true;
    MyFoxPawn.MyFoxWeapon.ScopeMod.ScopePPSettings.DOF_FalloffExponent = NewSize;
    //return;    
}

exec function TweakOffsetWeight(float NewValue)
{
    MyFoxPawn.MyFoxWeapon.SpreadOffsetNormalWeight = NewValue;
    MyFoxPawn.MyFoxWeapon.SpreadOffsetTightAimWeight = NewValue;
    //return;    
}

exec function SuppressWeapon(bool bSuppress)
{
    FoxPRI(PlayerReplicationInfo).Loadout.SuppressWeapon(bSuppress);
    MyFoxPawn.MyFoxWeapon.InitializeAttachments();
    //return;    
}

exec function QueryFriends()
{
    OnlineSub.PlayerInterface.ReadFriendsList(0, 0, 0);
    //return;    
}

exec function AddFriend(string FriendName)
{
    OnlineSub.PlayerInterface.AddFriendByName(0, FriendName, "I love you man!");
    //return;    
}

exec function QueryBasicProfile()
{
    OnlineSub.StoreInterface.QueryProfile(PlayerReplicationInfo.UniqueId);
    //return;    
}

exec function ToggleAllowScreenDoorFade(bool bOn)
{
    class'Engine'.static.ToggleAllowScreenDoorFade(bOn);
    //return;    
}

exec function TestReportUI()
{
    local UniqueNetId ZeroId;

    DynamicUI.Menu.ShowReportPlayerDialog(ZeroId);
    //return;    
}

exec function DebugTeamBalance()
{
    local FoxTeamBalance ftb;
    local int I;

    I = 0;
    J0x0B:
    // End:0x60 [Loop If]
    if(I < 100)
    {
        ftb = new (self) class'FoxTeamBalance';
        ftb.DebugTeamBalance();
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

exec function ChangeTickRate(float NewRate)
{
    WorldInfo.TimeDilation = NewRate;
    //return;    
}

exec function SwapBackground(bool bBad)
{
    MenuBG.FadeOut();
    MenuBG.Close();
    MenuBG = none;
    // End:0xB1
    if(bBad)
    {
        MenuBG = new (self) class'FoxBadBackgroundUI';
        MenuBG.PCOwner = self;
        MenuBG.Initialize();
    }
    // End:0xBB
    else
    {
        InitializeBackgroundUI();
    }
    //return;    
}

exec function Killbackground()
{
    MenuBG.Close();
    MenuBG = none;
    MenuMesh.SetHidden(true);
    MenuMesh = none;
    //return;    
}

exec function ForceGC()
{
    ClientForceGarbageCollection();
    //return;    
}

exec function JoinGameAsParty()
{
    PartyInterface.SearchForGameAsParty();
    //return;    
}

exec function SetPartyLimit(int NewLimit, optional bool bEnforce)
{
    bEnforce = true;
    // End:0x96
    if((OnlineSub != none) && NotEqual_InterfaceInterface(OnlineSub.PartyInterface, (none)))
    {
        // End:0x96
        if(OnlineSub.PartyInterface.SetPartyLimit(NewLimit, bEnforce))
        {
        }
    }
    //return;    
}

exec function TestHitBySounds(byte HitSoundtype)
{
    ClientPlayHitBySound(HitSoundtype);
    //return;    
}

exec function ToggleClientSideHitDetection(bool bTurnOn)
{
    ServerToggleClientSideHitDetection(bTurnOn);
    //return;    
}

reliable server function ServerToggleClientSideHitDetection(bool bTurnOn)
{
    WorldInfo.GRI.bClientSideHitDetection = bTurnOn;
    //return;    
}

exec function PlayGiveDamageSound()
{
    PostAkEvent(BodyHitSound, true);
    //return;    
}

exec function PlayTakeDamageSound()
{
    PostAkEvent(BodyHitBySound, true);
    //return;    
}

exec function SetControllerSensitivity(float InSens)
{
    MyFoxInput.ControllerSensitivityMultiplier = InSens;
    //return;    
}

exec function SetControllerTightAimSensitivity(float InSens)
{
    MyFoxInput.ControllerADSSensitivityMultiplier = InSens;
    //return;    
}

exec function DoRawCreate(optional string playlistName, optional string ServerOptions)
{
    local FoxPC LocalPlayer;
    local FoxUI UI;
    local PlayerController LocalPC;

    LocalPC = class'Actor'.static.GetALocalPlayerController();
    // End:0x56
    if(LocalPC != none)
    {
        LocalPlayer = FoxPC(LocalPC);
    }
    UI = ((LocalPlayer != none) ? LocalPlayer.DynamicUI : none);
    // End:0x1C7
    if(UI != none)
    {
        // End:0x10D
        if(UI.Menu.GameSearchQuickOnline != none)
        {
            UI.Menu.Cleanup();
        }
        UI.Menu.GameSearchQuickOnline = new (UI.Menu) class'FoxGameSearchQuickOnlineGame';
        UI.Menu.GameSearchQuickOnline.TryCreateOnlineGame(playlistName, ServerOptions);
    }
    //return;    
}

exec function DoSearchCreate(optional string playlistName, optional string ServerOptions)
{
    local FoxPC LocalPlayer;
    local FoxUI UI;
    local PlayerController LocalPC;

    LocalPC = class'Actor'.static.GetALocalPlayerController();
    // End:0x56
    if(LocalPC != none)
    {
        LocalPlayer = FoxPC(LocalPC);
    }
    UI = ((LocalPlayer != none) ? LocalPlayer.DynamicUI : none);
    // End:0x2A7
    if(UI != none)
    {
        // End:0x10D
        if(UI.Menu.GameSearchQuickOnline != none)
        {
            UI.Menu.Cleanup();
        }
        UI.Menu.GameSearchQuickOnline = new (UI.Menu) class'FoxGameSearchQuickOnlineGame';
        UI.Menu.GameSearchQuickOnline.bAutoJoinGame = true;
        UI.Menu.GameSearchQuickOnline.bAutoCreateGame = true;
        UI.Menu.GameSearchQuickOnline.Initialize(0);
        UI.Menu.GameSearchQuickOnline.BeginOnlineSearch(playlistName, ServerOptions);
    }
    //return;    
}

exec function DoRawSearch(optional string playlistName, optional string ServerOptions)
{
    local FoxPC LocalPlayer;
    local FoxUI UI;
    local PlayerController LocalPC;

    LocalPC = class'Actor'.static.GetALocalPlayerController();
    // End:0x56
    if(LocalPC != none)
    {
        LocalPlayer = FoxPC(LocalPC);
    }
    UI = ((LocalPlayer != none) ? LocalPlayer.DynamicUI : none);
    // End:0x2A7
    if(UI != none)
    {
        // End:0x10D
        if(UI.Menu.GameSearchQuickOnline != none)
        {
            UI.Menu.Cleanup();
        }
        UI.Menu.GameSearchQuickOnline = new (UI.Menu) class'FoxGameSearchQuickOnlineGame';
        UI.Menu.GameSearchQuickOnline.bAutoJoinGame = false;
        UI.Menu.GameSearchQuickOnline.bAutoCreateGame = false;
        UI.Menu.GameSearchQuickOnline.Initialize(0);
        UI.Menu.GameSearchQuickOnline.BeginOnlineSearch(playlistName, ServerOptions);
    }
    //return;    
}

exec function DoJoinIndex(int RoomIndex)
{
    local FoxPC LocalPlayer;
    local FoxUI UI;
    local PlayerController LocalPC;

    LocalPC = class'Actor'.static.GetALocalPlayerController();
    // End:0x54
    if(LocalPC != none)
    {
        LocalPlayer = FoxPC(LocalPC);
    }
    UI = ((LocalPlayer != none) ? LocalPlayer.DynamicUI : none);
    // End:0x12C
    if(UI != none)
    {
        // End:0x12C
        if(UI.Menu.GameSearchQuickOnline != none)
        {
            UI.Menu.GameSearchQuickOnline.ProcessJoinSelection(RoomIndex);
            J0x12C:
        }
        // End:0x12C
        else
        {
        }
    }
    //return;    
}

exec function CreateCustomGame(string ServerName, string Password, int MapIndex, int GameModeIndex, bool bPremiumMatch)
{
    local FoxGameSettingsCommon NewSettings;
    local int PlaylistOption;

    NewSettings = new class'FoxGameSettingsCommon';
    NewSettings.SetServerType(((bPremiumMatch) ? 2 : 1));
    NewSettings.SetStringProperty(1073741830, Password);
    NewSettings.SetStringProperty(1073741833, ServerName);
    PlaylistOption = (MapIndex + 1) | ((GameModeIndex + 1) << 4);
    NewSettings.SetIntProperty(268435587, PlaylistOption);
    NewSettings.SetIntProperty(268435588, 0);
    NewSettings.SetIntProperty(268435589, 0);
    NewSettings.SetIntProperty(268435590, 0);
    NewSettings.bIsLanMatch = false;
    // End:0x1E0
    if(bPremiumMatch)
    {
        NewSettings.SetStringProperty(268435592, "2da4cb74-a7cf-4916-a65f-9598bdfc11a7");
    }
    OnlineSub.GameInterface.AddCreateOnlineGameCompleteDelegate(OnCreatePrivateMatchComplete);
    OnlineSub.GameInterface.CreateOnlineGame(0, 'Game', NewSettings);
    //return;    
}

function OnCreatePrivateMatchComplete(name SessionNam, bool bWasSuccessful)
{
    local string ConnectString, Password;

    OnlineSub.GameInterface.ClearCreateOnlineGameCompleteDelegate(OnCreatePrivateMatchComplete);
    // End:0x13A
    if(bWasSuccessful)
    {
        OnlineSub.GameInterface.GetResolvedConnectString('Game', ConnectString);
        OnlineSub.GameInterface.GetGameSettings('Game').GetStringProperty(1073741830, Password);
        ConsoleCommand((("Open" @ ConnectString) @ "?Password=") $ Password);
    }
    //return;    
}

exec function StartListenServer(string Playlist, optional string ExtraURLParameters)
{
    local FoxDataStore_Playlists PlaylistDataStore;

    PlaylistDataStore = GetPlaylistsDataStore();
    PlaylistDataStore.ResetCycleInfo();
    PlaylistDataStore.SelectPlaylistByName(name(Playlist));
    // End:0xDC
    if(ExtraURLParameters != "")
    {
        ConsoleCommand((("open FoxEntry?listen?Game=FoxGame." $ string(PlaylistDataStore.GetGameClass())) $ "?") $ ExtraURLParameters);
    }
    // End:0x137
    else
    {
        ConsoleCommand("open FoxEntry?listen?Game=FoxGame." $ string(PlaylistDataStore.GetGameClass()));
    }
    //return;    
}

exec function TestNetConnection()
{
    //return;    
}

exec function SetIdleKickTime(float IdleKickTime)
{
    ServerSetIdleKickTime(IdleKickTime);
    //return;    
}

reliable server function ServerSetIdleKickTime(float NewIdleKickTime)
{
    WorldInfo.Game.MaxIdleTime = NewIdleKickTime;
    //return;    
}

function TestServerAvail(byte RegionID)
{
    DynamicUI.Menu.Login.QueryAllServers();
    //return;    
}

function TestDestoryBeacon()
{
    MyRespawnBeacon.DoExplosion();
    //return;    
}

exec function SkipMap()
{
    ServerSkipMap();
    //return;    
}

reliable server function ServerSkipMap()
{
    // End:0xEA
    if((FoxGRI(WorldInfo.GRI).GameFlow != none) && FoxIntermission(FoxGRI(WorldInfo.GRI).GameFlow) != none)
    {
        FoxIntermission(FoxGRI(WorldInfo.GRI).GameFlow).SkipNextMap();
    }
    //return;    
}

exec function SetHealth(int newHealth)
{
    ServerSetHealth(newHealth);
    //return;    
}

reliable server function ServerSetHealth(int newHealth)
{
    Pawn.HealthMax = newHealth;
    Pawn.Health = newHealth;
    //return;    
}

simulated exec function SetMutatorEnabled(Engine.OnlineSubsystemTypes.EMutatorToggleType Mutator, bool bEnabled)
{
    ServerSetMutatorEnabled(Mutator, bEnabled);
    //return;    
}

reliable server function ServerSetMutatorEnabled(Engine.OnlineSubsystemTypes.EMutatorToggleType Mutator, bool bEnabled)
{
    FoxGRI(WorldInfo.GRI).SetMutatorEnabled(Mutator, bEnabled);
    //return;    
}

exec function PrintMutators()
{
    local int SettingsMutator;

    FoxGameSettingsCommon(OnlineSub.GameInterface.GetGameSettings('Game')).GetMutatorSetting(SettingsMutator);
    //return;    
}

simulated exec function SetPingLimit(int NewLimit)
{
    ServerSetPingLimit(NewLimit);
    //return;    
}

reliable server function ServerSetPingLimit(int NewLimit)
{
    FoxGame(WorldInfo.Game).MaximumPing = NewLimit;
    //return;    
}

exec function KillAllBots()
{
    ServerKillAllBots();
    //return;    
}

reliable server function ServerKillAllBots()
{
    local FoxAIControllerInterface C;

    // End:0x8D
    foreach WorldInfo.AllControllers(class'FoxAIControllerInterface', C)
    {
        // End:0x8C
        if(C.Pawn != none)
        {
            C.Pawn.Suicide();
        }        
    }    
    //return;    
}

exec function SetAIDebugFlag(string AIName, bool bSet)
{
    local FoxAIControllerInterface P;

    // End:0xA1
    foreach WorldInfo.AllControllers(class'FoxAIControllerInterface', P)
    {
        // End:0xA0
        if(P.PlayerReplicationInfo.GetHumanReadableName() == AIName)
        {
            P.bDebug = bSet;
        }        
    }    
    //return;    
}

exec function TestLensEffect(string EffectToAdd)
{
    ClientAddFadingCameraLensEffect(class<FoxCameraLensEffect_Fading>(FoxPRI(PlayerReplicationInfo).Loadout.ResolveWpnContentByName(EffectToAdd)), none);
    //return;    
}

exec function TestInvincibility(float Time)
{
    MyFoxPawn.StartInvincibility(1.0);
    //return;    
}

exec function TestSpawnLensEffect()
{
    PlayerCamera.AddCameraLensEffect(class'FoxCameraLensEffect_Spawn');
    //return;    
}

exec function PrintListedParties()
{
    local int I, J;
    local FoxGame FGame;

    // End:0xFE
    if(WorldInfo.Game != none)
    {
        FGame = FoxGame(WorldInfo.Game);
        I = 0;
        J0x60:
        // End:0xFE [Loop If]
        if(I < FGame.Parties.Length)
        {
            J = 0;
            J0x98:
            // End:0xF0 [Loop If]
            if(J < FGame.Parties[I].PartyMembers.Length)
            {
                ++ J;
                // [Loop Continue]
                goto J0x98;
            }
            ++ I;
            // [Loop Continue]
            goto J0x60;
        }
    }
    //return;    
}

exec function PrintInventory()
{
    local Inventory Inv;

    Inv = Pawn.InvManager.InventoryChain;
    J0x3D:
    // End:0x77 [Loop If]
    if(Inv != none)
    {
        Inv = Inv.Inventory;
        // [Loop Continue]
        goto J0x3D;
    }
    //return;    
}

exec function ChangeLevelReq(int MinLevel, int MaxLevel)
{
    ServerChangeLevelReq(MinLevel, MaxLevel);
    //return;    
}

reliable server function ServerChangeLevelReq(int MinLevel, int MaxLevel)
{
    local FoxGameSettingsCommon GameSettings;
    local string sMinLevel, sMaxLevel;

    GameSettings = FoxGameSettingsCommon(OnlineSub.GameInterface.GetGameSettings('Game'));
    sMaxLevel = string(MaxLevel);
    sMinLevel = string(MinLevel);
    GameSettings.SetPropertyFromStringByName('MinLevel', sMinLevel);
    GameSettings.SetPropertyFromStringByName('MaxLevel', sMaxLevel);
    FoxGame(WorldInfo.Game).UpdateCacheFromGameSettingsMidMatch();
    //return;    
}

exec function DebugHRVCloak(bool bEnabled)
{
    ServerSetHRVCloak(bEnabled);
    //return;    
}

reliable server function ServerSetHRVCloak(bool bEnabled)
{
    MyFoxPawn.SetHRVCloak(bEnabled);
    //return;    
}

exec function DestroyBombTargets()
{
    local FoxGameObject_BombTarget BT;

    // End:0x4E
    foreach WorldInfo.DynamicActors(class'FoxGameObject_BombTarget', BT)
    {
        BT.NotifyExploded();        
    }    
    //return;    
}

exec function DebugCarriedObject()
{
    ServerDebugCarriedObject();
    //return;    
}

reliable server function ServerDebugCarriedObject()
{
    //return;    
}

exec function DebugDropBomb()
{
    ServerDebugDropBomb();
    //return;    
}

reliable server function ServerDebugDropBomb()
{
    FoxGRI_SND(WorldInfo.GRI).BombObject.Drop();
    FoxGameMP_CTF(WorldInfo.Game).RedFlag.Drop();
    FoxGameMP_CTF(WorldInfo.Game).BlueFlag.Drop();
    //return;    
}

exec function GetClanTagTimer()
{
    OnlineSub.ClanInterface.GetClanTag(FoxPRI(PlayerReplicationInfo).UniqueId);
    //return;    
}

exec function GetClanTagTest()
{
    SetTimer(0.20, true, 'GetClanTagTimer');
    //return;    
}

exec function DebugClanTag()
{
    //return;    
}

exec function DebugTeams()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x5B [Loop If]
    if(I < WorldInfo.GRI.PRIArray.Length)
    {
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

exec function SetMaxPlayers(int NewMaxPlayers)
{
    ServerSetMaxPlayers(NewMaxPlayers);
    //return;    
}

reliable server function ServerSetMaxPlayers(int NewMaxPlayers)
{
    WorldInfo.Game.MaxPlayers = NewMaxPlayers;
    //return;    
}

exec function SetNumBots(int NewNumBots)
{
    ServerSetNumBots(NewNumBots);
    //return;    
}

reliable server function ServerSetNumBots(int NewNumBots)
{
    FoxGame(WorldInfo.Game).SetNumBots(NewNumBots);
    //return;    
}

exec function DebugSquads()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x7B [Loop If]
    if(I < FoxTeamInfo(WorldInfo.GRI.Teams[0]).Squads.Length)
    {
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

exec function SetPlayerFreeze(bool bFreezeMovement)
{
    ServerSetPlayerFreeze(bFreezeMovement);
    //return;    
}

reliable server function ServerSetPlayerFreeze(bool bFreezeMovement)
{
    FoxGRI(WorldInfo.GRI).bSpawnFreeze = bFreezeMovement;
    //return;    
}

exec function DebugDeadPlayers()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x5B [Loop If]
    if(I < WorldInfo.GRI.PRIArray.Length)
    {
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

exec function ShowAllSpawnPoints()
{
    local PlayerStart CurrentStart;
    local float RadiusToUse;

    // End:0xC5
    if(FoxGame(WorldInfo.Game) != none)
    {
        RadiusToUse = (FoxGame(WorldInfo.Game).PSV_Current.CollidingPawnCollisionRadiusMultiplier * class'FoxPawn'.default.CylinderComponent.CollisionRadius) / 2.0;
    }
    // End:0x102
    else
    {
        RadiusToUse = class'FoxPawn'.default.CylinderComponent.CollisionRadius;
    }
    FlushPersistentDebugLines();
    // End:0x29E
    foreach WorldInfo.AllNavigationPoints(class'PlayerStart', CurrentStart)
    {
        // End:0x1A1
        if(!CurrentStart.bEnabled)
        {
            DrawDebugSphere(CurrentStart.Location, RadiusToUse, 10, 255, 255, 255, true);
            // End:0x29D
            continue;
        }
        // End:0x202
        if(CurrentStart.TeamIndex == 0)
        {
            DrawDebugSphere(CurrentStart.Location, RadiusToUse, 10, 0, 255, 0, true);
            // End:0x29D
            continue;
        }
        // End:0x263
        if(CurrentStart.TeamIndex == 1)
        {
            DrawDebugSphere(CurrentStart.Location, RadiusToUse, 10, 0, 0, 255, true);
            // End:0x29D
            continue;
        }
        DrawDebugSphere(CurrentStart.Location, RadiusToUse, 10, 255, 0, 0, true);        
    }    
    //return;    
}

exec function DebugRemainingTime()
{
    ServerDebugRemainingTime();
    //return;    
}

reliable server function ServerDebugRemainingTime()
{
    //return;    
}

exec function DebugForSpinning(optional bool bOn)
{
    bOn = true;
    AngularVelocity = vect(0.0, 0.0, 0.0);
    RotationRate = rot(0, 0, 0);
    //return;    
}

function DumpAIInfo()
{
    ServerDumpAIInfo();
    //return;    
}

reliable server function ServerDumpAIInfo()
{
    local FoxAIControllerInterface AIC;

    // End:0x35
    foreach WorldInfo.AllControllers(class'FoxAIControllerInterface', AIC)
    {        
    }    
    //return;    
}

exec function DebugBurstFire(int BurstCount)
{
    MyFoxPawn.MyFoxWeapon.BurstFireMax = BurstCount;
    //return;    
}

exec function DebugMeshes()
{
    //return;    
}

exec function RestoreMeshVis()
{
    // End:0x51
    if((ViewTarget != none) && FoxPawn(ViewTarget) != none)
    {
        FoxPawn(ViewTarget).RestoreMeshVisibility();
    }
    //return;    
}

exec function DebugNetOwner()
{
    PrintNetOwner();
    ServerDebugNetOwner();
    //return;    
}

reliable server function ServerDebugNetOwner()
{
    PrintNetOwner();
    //return;    
}

simulated function PrintNetOwner()
{
    //return;    
}

exec function DebugWeapons()
{
    local Weapon W;
    local InventoryManager InvMgr;
    local FoxPawn P;
    local Inventory Inv;

    // End:0x2F
    foreach WorldInfo.DynamicActors(class'Weapon', W)
    {        
    }    
    // End:0x5F
    foreach WorldInfo.DynamicActors(class'InventoryManager', InvMgr)
    {        
    }    
    P = FoxPawn(ViewTarget);
    // End:0x117
    if(P.InvManager != none)
    {
        Inv = P.InvManager.InventoryChain;
        J0xDD:
        // End:0x117 [Loop If]
        if(Inv != none)
        {
            Inv = Inv.Inventory;
            // [Loop Continue]
            goto J0xDD;
        }
    }
    //return;    
}

exec function DebugCamMode()
{
    //return;    
}

exec function TestCameraShake()
{
    ClientPlayCameraShake(MyFoxPawn.TakeDamageCameraShake);
    //return;    
}

exec function DebugNearbyObject()
{
    local FoxGameObject_Use UseObj;

    // End:0x3A
    if(MyFoxPawn != none)
    {
        UseObj = MyFoxPawn.NearbyUseObject;
    }
    // End:0x83
    else
    {
        // End:0x83
        if(FoxPawn(ViewTarget) != none)
        {
            UseObj = FoxPawn(ViewTarget).NearbyUseObject;
        }
    }
    // End:0x92
    if(UseObj != none)
    {
    }
    //return;    
}

exec function DebugMenus()
{
    //return;    
}

exec function SetDynamicUIDPG(int DPG)
{
    DynamicUI.SetSceneDPG(byte(DPG));
    //return;    
}

exec function PrintVisibleFrameRect()
{
    local float x0, y0, X1, Y1;

    DynamicUI.GetVisibleFrameRect(x0, y0, X1, Y1);
    //return;    
}

exec function ApplySafeFrameScale(float InScale)
{
    DynamicUI.ApplySafeFrameScale(InScale);
    //return;    
}

exec function LoginLocal()
{
    OnlineSub.PlayerInterface.Login(0, "LocalUser", "", true);
    //return;    
}

exec function UnlockAchievement(int AchievementId)
{
    OnlineSub.PlayerInterface.UnlockAchievement(0, AchievementId, 100.0);
    //return;    
}

exec function UnlockAllAchievements(int AchievementNum)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x75 [Loop If]
    if(I < AchievementNum)
    {
        OnlineSub.PlayerInterface.UnlockAchievement(0, I, 100.0);
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

exec function RedeemCode(string InCode)
{
    OnlineSub.StoreInterface.AddRedeemCodeCompleteDelegate(0, OnCodeRedeemed);
    OnlineSub.StoreInterface.RedeemCode(InCode);
    //return;    
}

function OnCodeRedeemed(string InCode, byte Result)
{
    OnlineSub.StoreInterface.ClearRedeemCodeCompleteDelegate(0, OnCodeRedeemed);
    //return;    
}

exec function TestOnScreenKeyboard(string Title, string Desc, string DefaultText, bool bPassword)
{
    OnlineSub.PlayerInterface.ShowKeyboardUI(0, Title, Desc, bPassword, false, false, DefaultText);
    //return;    
}

exec function ShowWaitTimer(int PosX, int PosY)
{
    // End:0xF0
    if(DynamicUI.Menu.Login != none)
    {
        DynamicUI.Menu.Login.ui_hideWaitTimer();
        DynamicUI.Menu.Login.ui_showWaitTimer(PosX, PosY, "LoginDialogText");
    }
    //return;    
}

exec function HideWaitTimer()
{
    // End:0x82
    if(DynamicUI.Menu.Login != none)
    {
        DynamicUI.Menu.Login.ui_hideWaitTimer();
    }
    //return;    
}

exec function ShowSplashWidget()
{
    // End:0x87
    if(DynamicUI.Menu != none)
    {
        DynamicUI.Menu.ui_addSplashWidget(-1050, -310, 75, 0, 100, "LoginInstructions", "", "");
    }
    //return;    
}

exec function HideSplashWidget()
{
    // End:0x58
    if(DynamicUI.Menu != none)
    {
        DynamicUI.Menu.ui_removeSplashWidget();
    }
    //return;    
}

exec function TestCreateCharacter()
{
    local CreatePlayerDialogBoxProperties Properties;

    DynamicUI.ShowCreatePlayerDialogBox(Properties);
    //return;    
}

exec function Logout(optional bool bForce)
{
    bForce = false;
    ReturnToTitle();
    //return;    
}

exec function Relogin()
{
    bAutoLogin = true;
    ReturnToTitle();
    //return;    
}

exec function ShowDownloadWatcherUI()
{
    DynamicUI.ui_showDownloadWatcher();
    //return;    
}

exec function HideDownloadWatcherUI()
{
    DynamicUI.ui_hideDownloadWatcher();
    //return;    
}

exec function TestDownloadNotification()
{
    DynamicUI.PumpSocialNotification(31);
    //return;    
}

exec function TestChat(string Channel, string Message)
{
    OnlineSub.ChatInterface.SendChat(Channel, Message);
    //return;    
}

exec function DumpProgresses()
{
    //return;    
}

exec function TestShowTitleStore(string Product, int Mode)
{
    OnlineSub.StoreInterface.AddTitleStorePurchaseCompleteDelegate(0, OnTitleStorePurchaseComplete);
    OnlineSub.StoreInterface.ShowTitleStore(Product, Mode);
    //return;    
}

exec function TestCloseTitleStore()
{
    OnlineSub.StoreInterface.CloseTitleStore();
    //return;    
}

function OnTitleStorePurchaseComplete(bool bResult)
{
    //return;    
}

exec function TestPlayerMet(string Description, string PlayerName, string PlayerID)
{
    local array<PlayerNameIdPair> AllPlayers;

    AllPlayers.Length = 1;
    AllPlayers[0].PlayerName = PlayerName;
    OnlineSub.StringToUniqueNetId(PlayerID, AllPlayers[1].UniqueId);
    OnlineSub.PlayerInterfaceEx.RecordPlayersRecentlyMet(0, AllPlayers, Description);
    //return;    
}

exec function TestInGamePost(int PostID)
{
    switch(PostID)
    {
        // End:0x48
        case 5:
            FoxPRI(PlayerReplicationInfo).AddInGamePost(5, "4");
            // End:0x171
            break;
        // End:0x4D
        case 6:
        // End:0x87
        case 8:
            FoxPRI(PlayerReplicationInfo).AddInGamePost(PostID);
            // End:0x171
            break;
        // End:0x8C
        case 9:
        // End:0x91
        case 10:
        // End:0x96
        case 11:
        // End:0x9B
        case 12:
        // End:0xDF
        case 13:
            FoxPRI(PlayerReplicationInfo).AddInGamePost(PostID, "Tastytofu");
            // End:0x171
            break;
        // End:0xE4
        case 2:
        // End:0xE9
        case 3:
        // End:0x12F
        case 4:
            FoxPRI(PlayerReplicationInfo).AddInGamePost(PostID, "42;32;21;10");
            // End:0x171
            break;
        // End:0x16E
        case 1:
            FoxPRI(PlayerReplicationInfo).AddInGamePost(PostID, "40010");
            // End:0x171
            break;
        // End:0xFFFF
        default:
            //return;
    }    
}

exec function InfiniteAmmo()
{
    FoxCheatManager(CheatManager).IA();
    //return;    
}

exec function DebugMyViewTarget()
{
    PrintViewTarget();
    // End:0x28
    if(Role < ROLE_Authority)
    {
        ServerDebugViewTarget();
    }
    //return;    
}

reliable server function ServerDebugViewTarget()
{
    PrintViewTarget();
    //return;    
}

simulated function PrintViewTarget()
{
    //return;    
}

exec function TestPlaylistPreserve()
{
    local FoxDataStore_Playlists PlaylistsDS;
    local array< class<FoxGame> > GameClasses;
    local array<string> MapNames;

    PlaylistsDS = GetPlaylistsDataStore();
    PlaylistsDS.SelectPlaylistByName(name("Private_CTF"));
    PlaylistsDS.PrintPairs();
    GameClasses.AddItem(class'FoxGameMP_CTF');
    GameClasses.AddItem(class'FoxGameMP_CTF');
    MapNames.AddItem("Piledriver1");
    MapNames.AddItem("Containment");
    PlaylistsDS.ForceSelections(GameClasses, MapNames);
    PlaylistsDS.PrintPairs();
    //return;    
}

exec function ShowTitleStoreIcon(Engine.OnlineSubsystemTypes.ETitleStoreIconLocation Where)
{
    OnlineSub.StoreInterface.ShowTitleStoreIcon(Where);
    //return;    
}

exec function HideTitleStoreIcon()
{
    OnlineSub.StoreInterface.HideTitleStoreIcon();
    //return;    
}

exec function ShowQuickMarket()
{
    DynamicUI.ui_ShowQuickMarket();
    //return;    
}

exec function HideQuickMarket()
{
    DynamicUI.ui_HideQuickmarket();
    //return;    
}

exec function QueryQoS()
{
    OnlineSub.StoreInterface.AddQoSQueriedCompleteDelegate(OnQoSQueried);
    OnlineSub.StoreInterface.QueryQoS();
    //return;    
}

function OnQoSQueried(bool bSuccessful, int PingInMs)
{
    OnlineSub.StoreInterface.ClearQoSQueriedCompleteDelegate(OnQoSQueried);
    //return;    
}

exec function ClanQuery()
{
    OnlineSub.ClanInterface.GetClanInfo("");
    //return;    
}

exec function ClanDisband()
{
    OnlineSub.ClanInterface.DisbandClan();
    //return;    
}

exec function ClanSetMOTD(string NewMOTD)
{
    OnlineSub.ClanInterface.AddOnSetClanMOTD(OnMOTDSet);
    OnlineSub.ClanInterface.SetClanMOTD(NewMOTD);
    //return;    
}

exec function ClanInviteByName(string PlayerName)
{
    local UniqueNetId BlankID;

    OnlineSub.ClanInterface.InviteToClan(PlayerName, BlankID);
    //return;    
}

exec function ClanExpand()
{
    DynamicUI.PurchaseItemByUnlockID(78, 0);
    //return;    
}

function OnMOTDSet(bool bSuccess, string NewMOTD)
{
    OnlineSub.ClanInterface.ClearOnSetClanMOTD(OnMOTDSet);
    //return;    
}

exec function SetRegion(int Region)
{
    DynamicUI.Menu.Login.SelectRegionByID(Region);
    OnlineSub.GameInterface.SetGameplayRegion(Region, bLimitMatchmakingRegions);
    // End:0xDE
    if(bLimitMatchmakingRegions)
    {
        ProfileSettings.SetSettingValueInt(203, ((Region > 0) ? 1 : 0));
    }
    // End:0x108
    else
    {
        ProfileSettings.SetSettingValueInt(202, Region);
    }
    SaveProfile("ISaidSo");
    //return;    
}

exec function LoginOnline(string User, string pass)
{
    DynamicUI.Menu.Login.ei_OnLoginButtonClicked(User, pass);
    //return;    
}

exec function EchoRegion()
{
    //return;    
}

exec function DebugMenuUIScene()
{
    // End:0x33
    if(DynamicUI != none)
    {
        // End:0x33
        if(DynamicUI.Menu != none)
        {
        }
    }
    //return;    
}

exec function DebugMMSearch(optional int Index)
{
    local FoxPC LocalPlayer;
    local FoxUI UI;
    local PlayerController LocalPC;

    Index = 1;
    LocalPC = class'Actor'.static.GetALocalPlayerController();
    // End:0x59
    if(LocalPC != none)
    {
        LocalPlayer = FoxPC(LocalPC);
    }
    UI = ((LocalPlayer != none) ? LocalPlayer.DynamicUI : none);
    // End:0x2E5
    if(UI != none)
    {
        // End:0x110
        if(UI.Menu.GameSearchQuickOnline != none)
        {
            UI.Menu.Cleanup();
        }
        UI.Menu.GameSearchQuickOnline = new (UI.Menu) class'FoxGameSearchQuickOnlineGame';
        UI.Menu.GameSearchQuickOnline.bAutoJoinGame = true;
        UI.Menu.GameSearchQuickOnline.bAutoCreateGame = false;
        UI.Menu.GameSearchQuickOnline.bAutoReQueueWhenSearchCompletesUnsuccessfully = false;
        UI.Menu.GameSearchQuickOnline.Initialize(0);
        UI.Menu.GameSearchQuickOnline.BeginOnlineSearch();
    }
    //return;    
}

function DialogBoxCallbackTest(FoxDialogBoxBase.EDialogBoxConfirmType Selection)
{
    //return;    
}

function DialogBoxStringCallbackTest(string Input)
{
    //return;    
}

exec function TestDialogBox(FoxDialogBox.EDialogBoxType InType)
{
    local DialogBoxProperties Props;

    Props.DialogType = InType;
    Props.TitleText = "Title Text";
    Props.BodyText = "Body Text";
    Props.bCloseOnButtonPress = true;
    Props.OnDialogButtonPressed = DialogBoxCallbackTest;
    Props.OnStringInputDelegate = DialogBoxStringCallbackTest;
    DynamicUI.ShowDialogBox(Props);
    //return;    
}

exec function CloseTestDialogBox()
{
    DynamicUI.CloseDialogBox();
    //return;    
}

exec function TestExpiredItemsDialogBox(int NumItems)
{
    local DialogBoxProperties Properties;
    local array<InventoryMetaData> Items;
    local FoxItemCacheInventory InventoryCache;
    local int NumToRemove;

    class'FoxDataStore_StoreData'.static.GetCachedInventory(InventoryCache);
    InventoryCache.GetCachedItems(Items);
    // End:0x7B
    if(Items.Length <= NumItems)
    {
        NumToRemove = 0;
    }
    // End:0x9A
    else
    {
        NumToRemove = Items.Length - NumItems;
    }
    // End:0xC6
    if(NumToRemove > 0)
    {
        Items.Remove(NumItems, NumToRemove);
    }
    Properties.DialogType = 8;
    Properties.TitleText = "TESTING EXPIRED ITEMS DIALOG BOX";
    Properties.BodyText = "THIS IS THE BODY TEXT";
    Properties.ItemList = Items;
    Properties.bCloseOnButtonPress = true;
    DynamicUI.ShowExpiredDialogBox(Properties);
    //return;    
}

exec function DebugPrint_DataStorePlaylistFilters()
{
    local FoxDataStore_MenuItems MenuItemsDataStore;
    local int I;

    MenuItemsDataStore = FoxDataStore_MenuItems(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxMenuItems'));
    I = 0;
    J0x5D:
    // End:0x98 [Loop If]
    if(I < class'FoxGame'.default.FilteredMapProviders.Length)
    {
        ++ I;
        // [Loop Continue]
        goto J0x5D;
    }
    I = 0;
    J0xA3:
    // End:0xDE [Loop If]
    if(I < class'FoxGame'.default.FilteredGameProviders.Length)
    {
        ++ I;
        // [Loop Continue]
        goto J0xA3;
    }
    I = 0;
    J0xE9:
    // End:0x124 [Loop If]
    if(I < MenuItemsDataStore.MapProviders.Length)
    {
        ++ I;
        // [Loop Continue]
        goto J0xE9;
    }
    I = 0;
    J0x12F:
    // End:0x16A [Loop If]
    if(I < MenuItemsDataStore.GameModeProviders.Length)
    {
        ++ I;
        // [Loop Continue]
        goto J0x12F;
    }
    //return;    
}

exec function PrintNumberOfPlaylistsEnabled()
{
    //return;    
}

exec function PrintNameOfCurrentPlaylist()
{
    //return;    
}

exec function ShowLoadingScreen()
{
    ShowLoadingMovie(true);
    //return;    
}

exec function HideLoadingScreen()
{
    ShowLoadingMovie(false);
    //return;    
}

exec function OutputAllLiveStreamingMods()
{
    local int I;
    local FoxPC FPC;
    local FoxPRI PRI;

    // End:0xBB
    foreach WorldInfo.AllControllers(class'FoxPC', FPC)
    {
        PRI = FoxPRI(FPC.PlayerReplicationInfo);
        // End:0xBA
        if(PRI != none)
        {
            I = 0;
            J0x7F:
            // End:0xBA [Loop If]
            if(I < PRI.LiveStreamingMods.Length)
            {
                ++ I;
                // [Loop Continue]
                goto J0x7F;
            }
        }        
    }    
    //return;    
}

exec function ActivateLiveStreamingMod(string Mod)
{
    ServerActivateLiveStreamingMod(Mod);
    //return;    
}

reliable server function ServerActivateLiveStreamingMod(string Mod)
{
    local class<FoxLiveStreamingMod> FoxLiveStreamingModClass;
    local FoxLiveStreamingMod NewFoxLiveStreamingMod;
    local FoxPRI PRI;

    FoxLiveStreamingModClass = class<FoxLiveStreamingMod>(DynamicLoadObject("FoxGame." $ Mod, class'Class'));
    // End:0x114
    if(FoxLiveStreamingModClass != none)
    {
        NewFoxLiveStreamingMod = new FoxLiveStreamingModClass;
        PRI = FoxPRI(PlayerReplicationInfo);
        // End:0x111
        if(PRI != none)
        {
            PRI.LiveStreamingMods.AddItem(NewFoxLiveStreamingMod);
            PRI.LiveStreamingMods[PRI.LiveStreamingMods.Length - 1].Start(self);
        }
        J0x114:
    }
    // End:0x114
    else
    {
    }
    //return;    
}

exec function RemoveLiveStreamingMod(string Mod)
{
    local class<FoxLiveStreamingMod> FoxLiveStreamingModClass;
    local FoxPRI PRI;
    local int I;

    FoxLiveStreamingModClass = class<FoxLiveStreamingMod>(DynamicLoadObject("FoxGame." $ Mod, class'Class'));
    PRI = FoxPRI(PlayerReplicationInfo);
    // End:0x179
    if(PRI != none)
    {
        I = 0;
        J0x72:
        // End:0x179 [Loop If]
        if(I < PRI.LiveStreamingMods.Length)
        {
            // End:0x16B
            if(PRI.LiveStreamingMods[I].Running() && FoxLiveStreamingModClass == PRI.LiveStreamingMods[I].Class)
            {
                PRI.LiveStreamingMods[I].End();
            }
            ++ I;
            // [Loop Continue]
            goto J0x72;
        }
    }
    //return;    
}

exec function TwitchMsg(const string msg)
{
    local FoxPC LocalPlayer;
    local PlayerController LocalPC;

    LocalPC = class'Actor'.static.GetALocalPlayerController();
    // End:0x54
    if(LocalPC != none)
    {
        LocalPlayer = FoxPC(LocalPC);
    }
    // End:0x8B
    if(LocalPlayer != none)
    {
        LocalPlayer.OnLiveStreamingCommandReceived(msg);
    }
    //return;    
}

exec function TwitchBeginVote()
{
    local PlayerController LocalPC;
    local FoxPRI MyFoxPRI;

    LocalPC = class'Actor'.static.GetALocalPlayerController();
    // End:0x69
    if(LocalPC != none)
    {
        MyFoxPRI = FoxPRI(LocalPC.PlayerReplicationInfo);
    }
    // End:0x97
    if(MyFoxPRI != none)
    {
        MyFoxPRI.BeginVote();
    }
    //return;    
}

exec function TwitchCancelVote()
{
    local PlayerController LocalPC;
    local FoxPRI MyFoxPRI;

    LocalPC = class'Actor'.static.GetALocalPlayerController();
    // End:0x69
    if(LocalPC != none)
    {
        MyFoxPRI = FoxPRI(LocalPC.PlayerReplicationInfo);
    }
    // End:0x97
    if(MyFoxPRI != none)
    {
        MyFoxPRI.CancelVote();
    }
    //return;    
}

exec function TwitchOnVoteComplete(const string WinningCategory)
{
    local PlayerController LocalPC;
    local FoxPRI MyFoxPRI;

    LocalPC = class'Actor'.static.GetALocalPlayerController();
    // End:0x69
    if(LocalPC != none)
    {
        MyFoxPRI = FoxPRI(LocalPC.PlayerReplicationInfo);
    }
    // End:0xA0
    if(MyFoxPRI != none)
    {
        MyFoxPRI.OnVoteCompleted(WinningCategory);
    }
    //return;    
}

exec function ChangeLookSens(float NewVal)
{
    ProfileSettings.SetGamepadSensitivitySetting(NewVal);
    ApplyControlsSettings();
    //return;    
}

exec function ChangeADSLookSens(float NewVal)
{
    ProfileSettings.SetGamepadTightAimSensitivity(NewVal);
    ApplyControlsSettings();
    //return;    
}

exec function AdjustLookUpScale(float NewVal)
{
    MyFoxInput.LookUpScale = NewVal;
    //return;    
}

exec function SetWeaponSkinByName(string SkinName)
{
    local FoxDataProvider_WeaponSkin SkinProvider;
    local FoxDataStore_Unlockables UnlockablesDataStore;
    local int I;
    local FoxWeaponPresetInfo PresetInfo;
    local class<FoxWeapon> NewWeaponClass;
    local Inventory Inventory;

    // End:0x2A
    if(Role < ROLE_Authority)
    {
        ServerSetWeaponSkinByName(SkinName);
    }
    // End:0x3BF
    else
    {
        UnlockablesDataStore = FoxDataStore_Unlockables(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxUnlockables'));
        I = 0;
        J0x87:
        // End:0x144 [Loop If]
        if(I < UnlockablesDataStore.PrimarySkinProviderArray.Length)
        {
            // End:0x136
            if(string(UnlockablesDataStore.PrimarySkinProviderArray[I].Name) ~= SkinName)
            {
                SkinProvider = UnlockablesDataStore.PrimarySkinProviderArray[I];
                // [Explicit Break]
                goto J0x144;
            }
            ++ I;
            J0x144:
            // [Loop Continue]
            goto J0x87;
        }
        // End:0x21B
        if(SkinProvider == none)
        {
            I = 0;
            J0x15E:
            // End:0x21B [Loop If]
            if(I < UnlockablesDataStore.SecondarySkinProviderArray.Length)
            {
                // End:0x20D
                if(string(UnlockablesDataStore.SecondarySkinProviderArray[I].Name) ~= SkinName)
                {
                    SkinProvider = UnlockablesDataStore.PrimarySkinProviderArray[I];
                    // [Explicit Break]
                    goto J0x21B;
                }
                ++ I;
                J0x21B:
                // [Loop Continue]
                goto J0x15E;
            }
        }
        // End:0x3BF
        if(SkinProvider != none)
        {
            NewWeaponClass = class<FoxWeapon>(class'FoxLoadoutInfo'.static.ResolveWpnContentByName(SkinProvider.WhiteRecievers[0]));
            class'FoxUnlockInfo'.static.GetDefaultPresetForWeaponClass(NewWeaponClass, PresetInfo);
            // End:0x3BF
            if(FoxPRI(PlayerReplicationInfo).Loadout.TryChangeCurrentWeaponConfig(NewWeaponClass, PresetInfo, I))
            {
                // End:0x3BF
                if(((NewWeaponClass != none) && Pawn != none) && Pawn.IsAliveAndWell())
                {
                    Inventory = Spawn(NewWeaponClass);
                    Inventory.GiveTo(Pawn);
                    Inventory.AnnouncePickup(Pawn);
                }
            }
        }
    }
    //return;    
}

exec function SpawnFakePlayers(int NumPlayers, optional int MaxPartySize)
{
    local FoxPC PC;
    local FoxPRI PRI;
    local FoxGame FGame;
    local int I, J;
    local array<FoxPC> CreatedPlayers;
    local int PartySize;
    local PartyList PL;

    MaxPartySize = 1;
    FGame = FoxGame(WorldInfo.Game);
    I = 0;
    J0x41:
    // End:0x17A [Loop If]
    if(I < NumPlayers)
    {
        PC = Spawn(class'FoxPC', self);
        // End:0x16C
        if((PC != none) && PC.PlayerReplicationInfo != none)
        {
            PRI = FoxPRI(PC.PlayerReplicationInfo);
            PRI.Skill += RandRange(0.0, 100000.0);
            PRI.PlayerName = "FakePlayer_" $ string(I);
            CreatedPlayers[CreatedPlayers.Length] = PC;
        }
        ++ I;
        // [Loop Continue]
        goto J0x41;
    }
    // End:0x409
    if(((FGame != none) && CreatedPlayers.Length > 0) && MaxPartySize > 1)
    {
        FGame.Parties.Length = 0;
        PartySize = Rand(MaxPartySize - 2) + 2;
        J0x1EA:
        // End:0x39E [Loop If]
        if(CreatedPlayers.Length > 0)
        {
            PRI = FoxPRI(CreatedPlayers[0].PlayerReplicationInfo);
            PL.PartyMembers[PL.PartyMembers.Length] = PRI;
            PartySize -= 1;
            PRI.PlayerName = ((PRI.PlayerName $ " PARTY [") $ string(FGame.Parties.Length)) $ "]";
            CreatedPlayers[0] = none;
            CreatedPlayers.Remove(0, 1);
            // End:0x39B
            if(PartySize == 0)
            {
                FGame.Parties[FGame.Parties.Length] = PL;
                PartySize = Rand(MaxPartySize - 2) + 2;
                PL.PartyMembers.Length = 0;
            }
            // [Loop Continue]
            goto J0x1EA;
        }
        // End:0x409
        if(PL.PartyMembers.Length > 0)
        {
            FGame.Parties[FGame.Parties.Length] = PL;
        }
    }
    I = 0;
    J0x414:
    // End:0x4B2 [Loop If]
    if(I < FGame.Parties.Length)
    {
        J = 0;
        J0x44C:
        // End:0x4A4 [Loop If]
        if(J < FGame.Parties[I].PartyMembers.Length)
        {
            ++ J;
            // [Loop Continue]
            goto J0x44C;
        }
        ++ I;
        // [Loop Continue]
        goto J0x414;
    }
    //return;    
}

reliable server function ServerSetWeaponSkinByName(string SkinName)
{
    SetWeaponSkinByName(SkinName);
    //return;    
}

exec function SetBadgeIndex(int NewBadgeIndex)
{
    local ProfileGearInfo GearInfo;

    GearInfo = FoxPRI(PlayerReplicationInfo).Loadout.GetCurrentGearInfo();
    GearInfo.BadgeID = NewBadgeIndex;
    MyFoxPawn.SetGear(GearInfo);
    //return;    
}

exec function AddNewFriend(string FriendName)
{
    DynamicUI.ei_AddFriend(FriendName);
    //return;    
}

exec function SetTaunt(int tauntID)
{
    local ProfileTauntInfo TauntData;

    TauntData.TauntID0 = tauntID;
    FoxPRI(PlayerReplicationInfo).Loadout.SetCurrentTaunts(TauntData);
    //return;    
}

exec function SetHudSkin(int skinID)
{
    ProfileSettings.SetSettingValueInt(716, skinID);
    DynamicUI.HUD.ReInitializeMainHud(true);
    //return;    
}

exec function TestAnnouncement()
{
    DynamicUI.ShowAnnouncementDialogBoxAutomatic();
    //return;    
}

exec function TestSafeDisconnect()
{
    local FoxPC LocalPlayer;
    local PlayerController LocalPC;

    LocalPC = class'Actor'.static.GetALocalPlayerController();
    // End:0x54
    if(LocalPC != none)
    {
        LocalPlayer = FoxPC(LocalPC);
    }
    // End:0x84
    if(LocalPlayer != none)
    {
        LocalPlayer.OnConnectionStatusChangeSafe(2);
    }
    //return;    
}

exec function ShowNewAAR()
{
    DynamicUI.Menu.ui_ShowAAR();
    //return;    
}

exec function CloseNewAAR()
{
    DynamicUI.Menu.ui_CloseAAR();
    //return;    
}

exec function TestPickupNotification(name DataProviderName, int Index)
{
    ClientNotifyGenericPickup(DataProviderName, Index);
    //return;    
}

exec function FakeKills(int Number)
{
    local FoxOnlineStatsWriteWeaponUse KillerWeaponUsageStats;

    KillerWeaponUsageStats = FoxPRI(PlayerReplicationInfo).WeaponUsageStats;
    KillerWeaponUsageStats.IncrementKills(class<FoxDamageType>(MyFoxPawn.MyFoxWeapon.InstantHitDamageTypes[0]));
    //return;    
}

exec function GiveSelfRevive()
{
    MyDeadPawn.GiveRevive(FoxPRI(PlayerReplicationInfo));
    //return;    
}

exec function PurchaseMultipleTest1()
{
    local array<string> Guids, Attachments;

    Guids.Length = 0;
    Attachments.Length = 0;
    OnlineSub.StoreInterface.AddPurchaseMultipleItemsCompleteDelegate(0, OnPurchaseMultipleResult);
    OnlineSub.StoreInterface.PurchaseMultipleItems(Guids, Attachments, 100, 1.0, 0, 0);
    //return;    
}

exec function PurchaseMultipleTest2()
{
    local array<string> Guids, Attachments;

    Guids[0] = "abcd";
    Attachments[0] = "3553";
    OnlineSub.StoreInterface.AddPurchaseMultipleItemsCompleteDelegate(0, OnPurchaseMultipleResult);
    OnlineSub.StoreInterface.PurchaseMultipleItems(Guids, Attachments, 100, 1.0, 0, 1);
    //return;    
}

exec function PurchaseMultipleTest3()
{
    local array<string> Guids, Attachments;

    Guids[0] = "abcd";
    Attachments[0] = "123";
    OnlineSub.StoreInterface.AddPurchaseMultipleItemsCompleteDelegate(0, OnPurchaseMultipleResult);
    OnlineSub.StoreInterface.PurchaseMultipleItems(Guids, Attachments, 100, 1.0, 0, 0);
    //return;    
}

exec function PurchaseMultipleTest4()
{
    local array<string> Guids, Attachments;

    Guids[0] = "8cf81b9a-1470-4e65-b076-08e5ccb829c4";
    Attachments[0] = "";
    OnlineSub.StoreInterface.AddPurchaseMultipleItemsCompleteDelegate(0, OnPurchaseMultipleResult);
    OnlineSub.StoreInterface.PurchaseMultipleItems(Guids, Attachments, 100, 1.0, 0, 0);
    //return;    
}

exec function PurchaseMultipleTest5()
{
    local array<string> Guids, Attachments;

    Guids[0] = "8cf81b9a-1470-4e65-b076-08e5ccb829c4";
    Attachments[0] = "";
    OnlineSub.StoreInterface.AddPurchaseMultipleItemsCompleteDelegate(0, OnPurchaseMultipleResult);
    OnlineSub.StoreInterface.PurchaseMultipleItems(Guids, Attachments, 250, 1.0, 0, 1);
    //return;    
}

exec function PurchaseMultipleTest6()
{
    local array<string> Guids, Attachments;

    Guids[0] = "8cf81b9a-1470-4e65-b076-08e5ccb829c4";
    Attachments[0] = "";
    OnlineSub.StoreInterface.AddPurchaseMultipleItemsCompleteDelegate(0, OnPurchaseMultipleResult);
    OnlineSub.StoreInterface.PurchaseMultipleItems(Guids, Attachments, 125, 0.50, 0, 1);
    //return;    
}

exec function PurchaseMultipleTest7()
{
    local array<string> Guids, Attachments;

    Guids[0] = "8cf81b9a-1470-4e65-b076-08e5ccb829c4";
    Guids[1] = "garbage";
    Attachments[0] = "";
    Attachments[1] = "";
    OnlineSub.StoreInterface.AddPurchaseMultipleItemsCompleteDelegate(0, OnPurchaseMultipleResult);
    OnlineSub.StoreInterface.PurchaseMultipleItems(Guids, Attachments, 125, 0.50, 0, 1);
    //return;    
}

exec function PurchaseMultipleTest8()
{
    local array<string> Guids, Attachments;

    Guids[0] = "8cf81b9a-1470-4e65-b076-08e5ccb829c4";
    Guids[1] = "ef3737ee-f485-4e8a-bcfe-18b0a211c8a8";
    Attachments[0] = "";
    Attachments[1] = "";
    OnlineSub.StoreInterface.AddPurchaseMultipleItemsCompleteDelegate(0, OnPurchaseMultipleResult);
    OnlineSub.StoreInterface.PurchaseMultipleItems(Guids, Attachments, 125, 1.0, 0, 1);
    //return;    
}

exec function PurchaseMultipleTest9()
{
    local array<string> Guids, Attachments;

    Guids[0] = "8cf81b9a-1470-4e65-b076-08e5ccb829c4";
    Guids[1] = "ef3737ee-f485-4e8a-bcfe-18b0a211c8a8";
    Attachments[0] = "";
    Attachments[1] = "";
    OnlineSub.StoreInterface.AddPurchaseMultipleItemsCompleteDelegate(0, OnPurchaseMultipleResult);
    OnlineSub.StoreInterface.PurchaseMultipleItems(Guids, Attachments, 500, 1.0, 0, 1);
    //return;    
}

exec function PurchaseMultipleTest10()
{
    local array<string> Guids, Attachments;

    Guids[0] = "8cf81b9a-1470-4e65-b076-08e5ccb829c4";
    Guids[1] = "ef3737ee-f485-4e8a-bcfe-18b0a211c8a8";
    Attachments[0] = "";
    Attachments[1] = "";
    OnlineSub.StoreInterface.AddPurchaseMultipleItemsCompleteDelegate(0, OnPurchaseMultipleResult);
    OnlineSub.StoreInterface.PurchaseMultipleItems(Guids, Attachments, 475, 0.950, 0, 1);
    //return;    
}

function OnPurchaseMultipleResult(const Engine.OnlineSubsystemTypes.EPurchaseMultipleResult Result, const array<string> InItems)
{
    OnlineSub.StoreInterface.ClearPurchaseMultipleItemCompleteDelegate(0, OnPurchaseMultipleResult);
    //return;    
}

exec function DumpBulkPurchaseList()
{
    // End:0xB9
    if(((DynamicUI != none) && DynamicUI.Menu != none) && DynamicUI.Menu.ArmoryInfo != none)
    {
        DynamicUI.Menu.ArmoryInfo.PrintBulkPurchaseList();
    }
    //return;    
}

exec function ShowBulkPurchaseDB()
{
    // End:0xB9
    if(((DynamicUI != none) && DynamicUI.Menu != none) && DynamicUI.Menu.ArmoryInfo != none)
    {
        DynamicUI.Menu.ArmoryInfo.ShowBulkPurchaseDB();
    }
    //return;    
}

exec function ShowArmoryTutorial(int TutorialStep)
{
    // End:0xC2
    if(((DynamicUI != none) && DynamicUI.Menu != none) && DynamicUI.Menu.ArmoryInfo != none)
    {
        DynamicUI.Menu.ArmoryInfo.ShowArmoryTutorial(TutorialStep);
    }
    //return;    
}

exec function ClearArmoryTutorialFlags()
{
    // End:0x2E
    if(ProfileSettings != none)
    {
        ProfileSettings.ClearLoadoutTutorialSeen();
    }
    //return;    
}

exec function ClearAccountMigrationPromptSeenProfileSetting()
{
    ProfileSettings.SetSettingValueInt(85, 0);
    SaveProfile("ClearAccountMigrationPromptSeenProfileSetting");
    //return;    
}

exec function ClearAccountMigrationCompleteSeenProfileSetting()
{
    ProfileSettings.SetSettingValueInt(86, 0);
    SaveProfile("ClearAccountMigrationCompleteSeenProfileSetting");
    //return;    
}

defaultproperties
{
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxAdmin.CollisionCylinder'
    CylinderComponent=CollisionCylinder
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxAdmin.CollisionCylinder'
    Components(0)=CollisionCylinder
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxAdmin.CollisionCylinder'
    CollisionComponent=CollisionCylinder
}